# LibArchive.jl: A Julia interface for libarchive

[![Build status](https://github.com/yuyichao/LibArchive.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/yuyichao/LibArchive.jl/actions/workflows/CI.yml)
[![codecov.io](http://codecov.io/github/yuyichao/LibArchive.jl/coverage.svg?branch=master)](http://codecov.io/github/yuyichao/LibArchive.jl?branch=master)

## Usage

read a binary file with lzma compression
```
reader = LibArchive.Reader(filename)
LibArchive.support_format_raw(reader)
LibArchive.support_filter_all(reader)
entry = LibArchive.next_header(reader)
arr = read(reader)
close(reader)
```

#

# Use module instead of baremodule to support document
module Status
"Found end of archive"
const EOF = Cint(1)
"Operation was successful"
const OK = Cint(0)
"Retry might succeed"
const RETRY = Cint(-10)
"Partial success"
const WARN = Cint(-20)
"Current operation cannot complete"
const FAILED = Cint(-25)
"No more operations are possible"
const FATAL = Cint(-30)
end

module FilterType
const NONE = Cint(0)
const GZIP = Cint(1)
const BZIP2 = Cint(2)
const COMPRESS = Cint(3)
const PROGRAM = Cint(4)
const LZMA = Cint(5)
const XZ = Cint(6)
const UU = Cint(7)
const RPM = Cint(8)
const LZIP = Cint(9)
const LRZIP = Cint(10)
const LZOP = Cint(11)
const GRZIP = Cint(12)
const LZ4 = Cint(14)
const ZSTD = Cint(15)
end

# Codes returned by archive_format.
#
# Top 16 bits identifies the format family (e.g., "tar"); lower
# 16 bits indicate the variant.  This is updated by read_next_header.
# Note that the lower 16 bits will often vary from entry to entry.
# In some cases, this variation occurs as libarchive learns more about
# the archive (for example, later entries might utilize extensions that
# weren't necessary earlier in the archive; in this case, libarchive
# will change the format code to indicate the extended format that
# was used).  In other cases, it's because different tools have
# modified the archive and so different parts of the archive
# actually have slightly different formats.  (Both tar and cpio store
# format codes in each entry, so it is quite possible for each
# entry to be in a different format.)
module Format
const BASE_MASK = Cint(0xff0000)
const CPIO = Cint(0x10000)
const CPIO_POSIX = Cint(CPIO | 1)
const CPIO_BIN_LE = Cint(CPIO | 2)
const CPIO_BIN_BE = Cint(CPIO | 3)
const CPIO_SVR4_NOCRC = Cint(CPIO | 4)
const CPIO_SVR4_CRC = Cint(CPIO | 5)
const CPIO_AFIO_LARGE = Cint(CPIO | 6)
const SHAR = Cint(0x20000)
const SHAR_BASE = Cint(SHAR | 1)
const SHAR_DUMP = Cint(SHAR | 2)
const TAR = Cint(0x30000)
const TAR_USTAR = Cint(TAR | 1)
const TAR_PAX_INTERCHANGE = Cint(TAR | 2)
const TAR_PAX_RESTRICTED = Cint(TAR | 3)
const TAR_GNUTAR = Cint(TAR | 4)
const ISO9660 = Cint(0x40000)
const ISO9660_ROCKRIDGE = Cint(ISO9660 | 1)
const ZIP = Cint(0x50000)
const EMPTY = Cint(0x60000)
const AR = Cint(0x70000)
const AR_GNU = Cint(AR | 1)
const AR_BSD = Cint(AR | 2)
const MTREE = Cint(0x80000)
const RAW = Cint(0x90000)
const XAR = Cint(0xA0000)
const LHA = Cint(0xB0000)
const CAB = Cint(0xC0000)
const RAR = Cint(0xD0000)
const _7ZIP = Cint(0xE0000)
const WARC = Cint(0xF0000)
const RAR_V5 = Cint(0x100000)
end

# Codes returned by format_capabilities(::Reader).
#
# This list can be extended with values between 0 and 0xffff.
# The original purpose of this list was to let different archive
# format readers expose their general capabilities in terms of
# encryption.
module ReadFormatCaps
"no special capabilities"
const NONE = Cint(0)
"reader can detect encrypted data"
const ENCRYPT_DATA = Cint(1 << 0)
"reader can detect encryptable metadata (pathname, mtime, etc.)"
const ENCRYPT_METADATA = Cint(1 << 1)
end

# Codes returned by archive_read_has_encrypted_entries().
#
# In case the archive does not support encryption detection at all
# ARCHIVE_READ_FORMAT_ENCRYPTION_UNSUPPORTED is returned. If the reader
# for some other reason (e.g. not enough bytes read) cannot say if
# there are encrypted entries, ARCHIVE_READ_FORMAT_ENCRYPTION_DONT_KNOW
# is returned.
module ReadFormatEncryption
const UNSUPPORTED = Cint(-2)
const DONT_KNOW = Cint(-1)
end

module ExtractFlag
"Default: Do not try to set owner/group."
const OWNER = Cint(0x0001)
"Default: Do obey umask, do not restore SUID/SGID/SVTX bits."
const PERM = Cint(0x0002)
"Default: Do not restore mtime/atime."
const TIME = Cint(0x0004)
"Default: Replace existing files."
const NO_OVERWRITE = Cint(0x0008)
"Default: Try create first, unlink only if create fails with EEXIST."
const UNLINK = Cint(0x0010)
"Default: Do not restore ACLs."
const ACL = Cint(0x0020)
"Default: Do not restore fflags."
const FFLAGS = Cint(0x0040)
"Default: Do not restore xattrs."
const XATTR = Cint(0x0080)
"""
Default: Do not try to guard against extracts redirected by symlinks.
Note: With UNLINK, will remove any intermediate symlink.
"""
const SECURE_SYMLINKS = Cint(0x0100)
"Default: Do not reject entries with '..' as path elements."
const SECURE_NODOTDOT = Cint(0x0200)
"Default: Create parent directories as needed."
const NO_AUTODIR = Cint(0x0400)
"Default: Overwrite files, even if one on disk is newer."
const NO_OVERWRITE_NEWER = Cint(0x0800)
"Detect blocks of 0 and write holes instead."
const SPARSE = Cint(0x1000)
"""
Default: Do not restore Mac extended metadata.
This has no effect except on Mac OS.
"""
const MAC_METADATA = Cint(0x2000)
"""
Default: Use HFS+ compression if it was compressed.
This has no effect except on Mac OS v10.6 or later.
"""
const NO_HFS_COMPRESSION = Cint(0x4000)
"""
Default: Do not use HFS+ compression if it was not compressed.
This has no effect except on Mac OS v10.6 or later.
"""
const HFS_COMPRESSION_FORCED = Cint(0x8000)
"Default: Do not reject entries with absolute paths"
const SECURE_NOABSOLUTEPATHS = Cint(0x10000)
"Default: Do not clear no-change flags when unlinking object"
const CLEAR_NOCHANGE_FFLAGS = Cint(0x20000)
"Default: Do not extract atomically (using rename)"
const SAFE_WRITES = Cint(0x40000)
end

module ReadDiskFlag
"""
Request that the access time of the entry visited by travesal be restored.
This is the same as archive_read_disk_set_atime_restored.
"""
const RESTORE_ATIME = Cint(0x0001)
"Default: Do not skip an entry which has nodump flags."
const HONOR_NODUMP = Cint(0x0002)
"""
Default: Skip a mac resource fork file whose prefix is "._" because of
using copyfile.
"""
const MAC_COPYFILE = Cint(0x0004)
"Default: Do not traverse mount points."
const NO_TRAVERSE_MOUNTS = Cint(0x0008)
"Default: Xattrs are read from disk."
const NO_XATTR = Cint(0x0010)
"Default: ACLs are read from disk."
const NO_ACL = Cint(0x0020)
"Default: File flags are read from disk."
const NO_FFLAGS = Cint(0x0040)
end

"""
Flags to tell a matching type of time stamps. These are used for
following functinos.
"""
module MatchFlag
"Time flag: mtime to be tested"
const MTIME = Cint(0x0100)
"Time flag: ctime to be tested"
const CTIME = Cint(0x0200)
"Comparison flag: Match the time if it is newer than"
const NEWER = Cint(0x0001)
"Comparison flag: Match the time if it is older than"
const OLDER = Cint(0x0002)
"Comparison flag: Match the time if it is equal to"
const EQUAL = Cint(0x0010)
end

module FileType
const MT = Cint(0o170000)
const REG = Cint(0o100000)
const LNK = Cint(0o120000)
const SOCK = Cint(0o140000)
const CHR = Cint(0o020000)
const BLK = Cint(0o060000)
const DIR = Cint(0o040000)
const IFO = Cint(0o010000)
const FIFO = IFO
end

module SymlinkType
const UNDEFINED = Cint(0)
const FILE = Cint(1)
const DIRECTORY = Cint(2)
end

module ACL
# Permission bits.

const EXECUTE = Cint(0x00000001)
const WRITE = Cint(0x00000002)
const READ = Cint(0x00000004)
const READ_DATA = Cint(0x00000008)
const LIST_DIRECTORY = Cint(0x00000008)
const WRITE_DATA = Cint(0x00000010)
const ADD_FILE = Cint(0x00000010)
const APPEND_DATA = Cint(0x00000020)
const ADD_SUBDIRECTORY = Cint(0x00000020)
const READ_NAMED_ATTRS = Cint(0x00000040)
const WRITE_NAMED_ATTRS = Cint(0x00000080)
const DELETE_CHILD = Cint(0x00000100)
const READ_ATTRIBUTES = Cint(0x00000200)
const WRITE_ATTRIBUTES = Cint(0x00000400)
const DELETE = Cint(0x00000800)
const READ_ACL = Cint(0x00001000)
const WRITE_ACL = Cint(0x00002000)
const WRITE_OWNER = Cint(0x00004000)
const SYNCHRONIZE = Cint(0x00008000)

const PERMS_POSIX1E = EXECUTE | WRITE | READ
const PERMS_NFS4 = (EXECUTE | READ_DATA | LIST_DIRECTORY | WRITE_DATA |
                    ADD_FILE | APPEND_DATA | ADD_SUBDIRECTORY |
                    READ_NAMED_ATTRS | WRITE_NAMED_ATTRS | DELETE_CHILD |
                    READ_ATTRIBUTES | WRITE_ATTRIBUTES | DELETE | READ_ACL |
                    WRITE_ACL | WRITE_OWNER | SYNCHRONIZE)

# Inheritance values (NFS4 ACLs only); included in permset.
const INHERITED = Cint(0x01000000)
const FILE_INHERIT = Cint(0x02000000)
const DIRECTORY_INHERIT = Cint(0x04000000)
const NO_PROPAGATE_INHERIT = Cint(0x08000000)
const INHERIT_ONLY = Cint(0x10000000)
const SUCCESSFUL_ACCESS = Cint(0x20000000)
const FAILED_ACCESS = Cint(0x40000000)

const INHERITANCE_NFS4 = (INHERITED | FILE_INHERIT | DIRECTORY_INHERIT |
                          NO_PROPAGATE_INHERIT | INHERIT_ONLY |
                          SUCCESSFUL_ACCESS | FAILED_ACCESS)

module Type
# We need to be able to specify combinations of these.
const ACCESS = Cint(0x00000100)  # POSIX.1e only
const DEFAULT = Cint(0x00000200) # POSIX.1e only
const ALLOW = Cint(0x00000400) # NFS4 only
const DENY = Cint(0x00000800) # NFS4 only
const AUDIT = Cint(0x00001000) # NFS4 only
const ALARM = Cint(0x00002000) # NFS4 only
const POSIX1E = (ACCESS | DEFAULT)
const NFS4 = (ALLOW | DENY | AUDIT | ALARM)
end

# Tag values mimic POSIX.1e
"Specified user."
const USER = Cint(10001)
"User who owns the file."
const USER_OBJ = Cint(10002)
"Specified group."
const GROUP = Cint(10003)
"Group who owns the file."
const GROUP_OBJ = Cint(10004)
"Modify group access (POSIX.1e only)"
const MASK = Cint(10005)
"Public (POSIX.1e only)"
const OTHER = Cint(10006)
"Everyone (NFS4 only)"
const EVERYONE = Cint(10107)

module Style
const EXTRA_ID = Cint(0x00000001)
const MARK_DEFAULT = Cint(0x00000002)
const SOLARIS = Cint(0x00000004)
const SEPARATOR_COMMA = Cint(0x00000008)
const COMPACT = Cint(0x00000010)
end
end

###
# Creating an archive
#
# To create an archive in C:
#     1. Ask `archive_write_new` for an archive writer object.
#     2. Set any global properties. In particular, you should set
#        the compression and format to use.
#     3. Call `archive_write_open` to open the file (most people
#         will use `archive_write_open_file` or `archive_write_open_fd`,
#         which provide convenient canned I/O callbacks for you).
#     4. For each entry:
#         * construct an appropriate `struct archive_entry` structure
#         * `archive_write_header` to write the header
#         * `archive_write_data` to write the entry data
#     5. `archive_write_close` to close the output
#     6. `archive_write_free` to cleanup the writer and release resources
#
# To create an archive in Julia:
#     1. Create a LibArchive.Writer
#     2. Set any global properties. In particular, you should set
#        the compression and format to use.
#     3. Write each entries. LibArchive.jl will call libarchive
#        open functions if needed.
#     4. Call LibArchive.free to end processing.

abstract type WriterData end

mutable struct Writer{T<:WriterData} <: Archive
    data::T
    ptr::Ptr{Cvoid}
    opened::Bool
    passphrase_mgr
    function Writer{T}(data::T) where T
        ptr = ccall((:archive_write_new, libarchive), Ptr{Cvoid}, ())
        ptr == C_NULL && throw(OutOfMemoryError())
        obj = new(data, ptr, false)
        finalizer(obj, free)
        obj
    end
end

Writer(data::T) where {T<:WriterData} = Writer{T}(data)

function free(archive::Writer)
    ptr = archive.ptr
    ptr == C_NULL && return
    ccall((:archive_write_free, libarchive), Cint, (Ptr{Cvoid},), ptr)
    archive.ptr = C_NULL
    nothing
end

Base.close(archive::Writer) =
    @_la_call(archive_write_close, (Ptr{Cvoid},), archive)

function Base.cconvert(::Type{Ptr{Cvoid}}, archive::Writer)
    archive.ptr == C_NULL && error("archive already freed")
    archive
end
Base.unsafe_convert(::Type{Ptr{Cvoid}}, archive::Writer) = archive.ptr

function ensure_open(archive::Writer)
    archive.opened && return
    archive.opened = true
    try
        do_open(archive)
    catch
        archive.opened = false
        rethrow()
    end
    nothing
end

set_bytes_per_block(archive::Writer, bytes_per_block) =
    @_la_call(archive_write_set_bytes_per_block, (Ptr{Cvoid}, Cint),
              archive, bytes_per_block)
get_bytes_per_block(archive::Writer) =
    ccall((:archive_write_get_bytes_per_block, libarchive),
          Cint, (Ptr{Cvoid},), archive)

set_bytes_in_last_block(archive::Writer, bytes_in_last_block) =
    @_la_call(archive_write_set_bytes_in_last_block, (Ptr{Cvoid}, Cint),
              archive, bytes_in_last_block)
get_bytes_in_last_block(archive::Writer) =
    ccall((:archive_write_get_bytes_in_last_block, libarchive),
          Cint, (Ptr{Cvoid},), archive)

"""
The dev/ino of a file that won't be archived. This is used
to avoid recursively adding an archive to itself.
"""
set_skip_file(archive::Writer, dev, ino) =
    @_la_call(archive_write_set_skip_file, (Ptr{Cvoid}, Int64, Int64),
              archive, dev, ino)

###
# Open filename

struct WriteFileName{T} <: WriterData
    name::T
end

Writer(fname::AbstractString) = Writer(WriteFileName(fname))
Writer() = Writer(WriteFileName(nothing))

function do_open(archive::Writer{WriteFileName{T}}) where T
    data = archive.data
    @_la_call(archive_write_open_filename, (Ptr{Cvoid}, Cstring),
              archive, data.name)
end

function do_open(archive::Writer{WriteFileName{Cvoid}})
    @_la_call(archive_write_open_filename, (Ptr{Cvoid}, Ptr{Cvoid}),
              archive, C_NULL)
end

struct WriteFD <: WriterData
    fd::Cint
end

Writer(fd::Integer) = Writer(WriteFD(Cint(fd)))

function do_open(archive::Writer{WriteFD})
    data = archive.data
    @_la_call(archive_write_open_fd, (Ptr{Cvoid}, Cint), archive, data.fd)
end

struct WriteFILE <: WriterData
    file::Libc.FILE
end

Writer(file::Libc.FILE) = Writer(WriteFILE(file))

function do_open(archive::Writer{WriteFILE})
    data = archive.data
    @_la_call(archive_write_open_FILE, (Ptr{Cvoid}, Ptr{Cvoid}), archive, data.file)
end

###
# Open memory

struct WriteMemory{T,TO} <: WriterData
    ptr::T
    obj::TO # Reference for GC
    size::Csize_t
    used::typeof(Ref{Csize_t}())
end

Writer(ptr::T, size, obj::TO=nothing) where {T<:Ptr,TO} =
    Writer(WriteMemory{T,TO}(ptr, obj, size, Ref(Csize_t(0))))
Writer(ary::Vector, size=sizeof(ary)) = Writer(pointer(ary), size, ary)

Base.unsafe_convert(::Type{Ptr{Cvoid}}, mem_data::WriteMemory) = mem_data.ptr

function do_open(archive::Writer{T}) where {T<:WriteMemory}
    data = archive.data
    @_la_call(archive_write_open_memory,
              (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t, Ptr{Csize_t}),
              archive, data, data.size, data.used)
end

get_used(archive::Writer{T}) where {T<:WriteMemory} = archive.data.used[]

###
# Generic writer

struct GenericWriteData{T} <: WriterData
    data::T
end

Writer(data::T) where {T} = Writer(GenericWriteData{T}(data))

writer_open(archive::Writer, data) = nothing
function writer_writebytes end
writer_close(archive::Writer, data) = nothing

function writer_open_callback(c_archive, archive)
    try
        clear_error(archive)
        writer_open(archive, archive.data.data)
        return Libc.errno(archive) == 0 ? Cint(0) : Status.WARN
    catch ex
        return set_exception(archive, ex)
    end
end

function writer_write_callback(c_archive, archive, buff::Ptr{Cvoid},
                               length::Csize_t)
    try
        clear_error(archive)
        ary = unsafe_wrap(Array, Ptr{UInt8}(buff), length)
        return Cssize_t(writer_writebytes(archive, archive.data.data, ary))
    catch ex
        set_exception(archive, ex)
        return Cssize_t(-1)
    end
end

function writer_close_callback(c_archive, archive)
    try
        clear_error(archive)
        writer_close(archive, archive.data.data)
        return Libc.errno(archive) == 0 ? Cint(0) : Status.WARN
    catch ex
        return set_exception(archive, ex)
    end
end

writer_writebytes(archive, io::IO, ary) = write(io, ary)

function do_open(archive::Writer{T}) where {T<:GenericWriteData}
    @_la_call(archive_write_open,
              (Ptr{Cvoid}, Any, Ptr{Cvoid}, Ptr{Cvoid}, Ptr{Cvoid}),
              archive, archive,
              @to_open_callback(writer_open_callback, Writer{T}),
              @to_write_callback(writer_write_callback, Writer{T}),
              @to_close_callback(writer_close_callback, Writer{T}))
end

function write_header(archive::Writer, entry::Entry)
    ensure_open(archive)
    @_la_call(archive_write_header, (Ptr{Cvoid}, Ptr{Cvoid}), archive, entry)
end

@inline function unsafe_archive_write(archive::Writer, buf, len)
    ensure_open(archive)
    nb = ccall((:archive_write_data, libarchive),
               Cssize_t, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t), archive, buf, len)
    nb < 0 && _la_error(Cint(nb), archive)
    nb % Csize_t
end

unsafe_write(archive::Writer, buf::Ptr{UInt8}, len::UInt) =
    unsafe_archive_write(archive, buf, len)
Base.write(archive::Writer, c::UInt8) =
    unsafe_archive_write(archive, Ref(c), 1)

function finish_entry(archive::Writer)
    ensure_open(archive)
    @_la_call(archive_write_finish_entry, (Ptr{Cvoid},), archive)
end

"""
Marks the archive as FATAL so that a subsequent free() operation
won't try to close() cleanly.  Provides a fast abort capability
when the client discovers that things have gone wrong.
"""
write_fail(archive::Writer) =
    @_la_call(archive_write_fail, (Ptr{Cvoid},), archive)

Writer(f::Function) = archive_guard(f, Writer())
Writer(f::Function, args...; kws...) =
    archive_guard(f, Writer(args...; kws...))

set_passphrase(writer::Writer, passphrase::AbstractString) =
    @_la_call(archive_write_set_passphrase, (Ptr{Cvoid}, Cstring), writer, passphrase)
function set_passphrase(writer::Writer, cb::Cb) where Cb
    mgr = PassphraseMgr(cb)
    fptr = @cfunction(_passphrase_cb, Ptr{UInt8}, (Ptr{Cvoid},Ref{PassphraseMgr{Cb}}))
    GC.@preserve mgr begin
        @_la_call(archive_write_set_passphrase_callback,
                  (Ptr{Cvoid}, Ref{PassphraseMgr{Cb}}, Ptr{Cvoid}),
                  writer, mgr, fptr)
    end
    writer.passphrase_mgr = mgr
    return
end

set_format_option(writer::Writer, m::AbstractString, o::AbstractString, v::AbstractString) =
    @_la_call(archive_write_set_format_option,
              (Ptr{Cvoid}, Cstring, Cstring, Cstring), writer, m, o, v)
set_filter_option(writer::Writer, m::AbstractString, o::AbstractString, v::AbstractString) =
    @_la_call(archive_write_set_filter_option,
              (Ptr{Cvoid}, Cstring, Cstring, Cstring), writer, m, o, v)
set_option(writer::Writer, m::AbstractString, o::AbstractString, v::AbstractString) =
    @_la_call(archive_write_set_option,
              (Ptr{Cvoid}, Cstring, Cstring, Cstring), writer, m, o, v)
set_options(writer::Writer, opts::AbstractString) =
    @_la_call(archive_write_set_options, (Ptr{Cvoid}, Cstring), writer, opts)

# TODO
# /* This interface is currently only available for archive_write_disk handles.  */
# ssize_t archive_write_data_block(struct archive *,
#                                  const void *, size_t, int64_t);

###
# Format and filters

# Format (i.e. how files are packed together)

# Reader

support_format_7zip(archive::Reader) =
    @_la_call(archive_read_support_format_7zip, (Ptr{Cvoid},), archive)
support_format_all(archive::Reader) =
    @_la_call(archive_read_support_format_all, (Ptr{Cvoid},), archive)
support_format_ar(archive::Reader) =
    @_la_call(archive_read_support_format_ar, (Ptr{Cvoid},), archive)
support_format_by_code(archive::Reader, code) =
    @_la_call(archive_read_support_format_by_code,
              (Ptr{Cvoid}, Cint), archive, code)
support_format_cab(archive::Reader) =
    @_la_call(archive_read_support_format_cab, (Ptr{Cvoid},), archive)
support_format_cpio(archive::Reader) =
    @_la_call(archive_read_support_format_cpio, (Ptr{Cvoid},), archive)
support_format_empty(archive::Reader) =
    @_la_call(archive_read_support_format_empty, (Ptr{Cvoid},), archive)
support_format_gnutar(archive::Reader) =
    @_la_call(archive_read_support_format_gnutar, (Ptr{Cvoid},), archive)
support_format_iso9660(archive::Reader) =
    @_la_call(archive_read_support_format_iso9660, (Ptr{Cvoid},), archive)
support_format_lha(archive::Reader) =
    @_la_call(archive_read_support_format_lha, (Ptr{Cvoid},), archive)
support_format_mtree(archive::Reader) =
    @_la_call(archive_read_support_format_mtree, (Ptr{Cvoid},), archive)
support_format_rar(archive::Reader) =
    @_la_call(archive_read_support_format_rar, (Ptr{Cvoid},), archive)
support_format_rar5(archive::Reader) =
    @_la_call(archive_read_support_format_rar5, (Ptr{Cvoid},), archive)
support_format_raw(archive::Reader) =
    @_la_call(archive_read_support_format_raw, (Ptr{Cvoid},), archive)
support_format_tar(archive::Reader) =
    @_la_call(archive_read_support_format_tar, (Ptr{Cvoid},), archive)
support_format_xar(archive::Reader) =
    @_la_call(archive_read_support_format_xar, (Ptr{Cvoid},), archive)
support_format_warc(archive::Reader) =
    @_la_call(archive_read_support_format_warc, (Ptr{Cvoid},), archive)
support_format_zip(archive::Reader) =
    @_la_call(archive_read_support_format_zip, (Ptr{Cvoid},), archive)
support_format_zip_streamable(archive::Reader) =
    @_la_call(archive_read_support_format_zip_streamable, (Ptr{Cvoid},), archive)
support_format_zip_seekable(archive::Reader) =
    @_la_call(archive_read_support_format_zip_seekable, (Ptr{Cvoid},), archive)

const _format_ids = Dict{String,Cint}(
    "7zip"=>Format._7ZIP,
    "ar"=>Format.AR_BSD,
    "arbsd"=>Format.AR_BSD,
    "argnu"=>Format.AR_GNU,
    "arsvr4"=>Format.AR_GNU,
    "bsdtar"=>Format.TAR_PAX_RESTRICTED,
    "cd9660"=>Format.ISO9660,
    "cpio"=>Format.CPIO_POSIX,
    "gnutar"=>Format.TAR_GNUTAR,
    "iso"=>Format.ISO9660,
    "iso9660"=>Format.ISO9660,
    "mtree"=>Format.MTREE,
    "mtree-classic"=>Format.MTREE,
    "newc"=>Format.CPIO_SVR4_NOCRC,
    "odc"=>Format.CPIO_POSIX,
    "oldtar"=>Format.TAR,
    "pax"=>Format.TAR_PAX_INTERCHANGE,
    "paxr"=>Format.TAR_PAX_RESTRICTED,
    "posix"=>Format.TAR_PAX_INTERCHANGE,
    "raw"=>Format.RAW,
    "rpax"=>Format.TAR_PAX_RESTRICTED,
    "shar"=>Format.SHAR_BASE,
    "shardump"=>Format.SHAR_DUMP,
    "ustar"=>Format.TAR_USTAR,
    "v7tar"=>Format.TAR,
    "v7"=>Format.TAR,
    "warc"=>Format.WARC,
    "xar"=>Format.XAR,
    "zip"=>Format.ZIP,
)

# Functions to manually set the format and filters to be used. This is
# useful to bypass the bidding process when the format and filters to use
# is known in advance.
set_format(archive::Reader, fmt::Integer) =
    @_la_call(archive_read_set_format, (Ptr{Cvoid}, Cint), archive, fmt)
function set_format(archive::Reader, fmt::AbstractString)
    id = get(_format_ids, fmt, Cint(-1))
    if id < 0
        throw(ArchiveFatal("No such format '$fmt'"))
    end
    @_la_call(archive_read_set_format, (Ptr{Cvoid}, Cint), archive, id)
end
set_format_7zip(archive::Reader) = set_format(archive, Format._7ZIP)
set_format_ar_bsd(archive::Reader) = set_format(archive, Format.AR_BSD)
set_format_ar_gnu(archive::Reader) = set_format(archive, Format.AR_GNU)
const set_format_ar_svr4 = set_format_ar_gnu
set_format_cpio(archive::Reader) = set_format(archive, Format.CPIO_POSIX)
set_format_cpio_newc(archive::Reader) = set_format(archive, Format.CPIO_SVR4_NOCRC)
set_format_gnutar(archive::Reader) = set_format(archive, Format.TAR_GNUTAR)
set_format_iso9660(archive::Reader) = set_format(archive, Format.ISO9660)
set_format_mtree(archive::Reader) = set_format(archive, Format.MTREE)
set_format_mtree_classic(archive::Reader) = set_format(archive, Format.MTREE)
set_format_pax(archive::Reader) = set_format(archive, Format.TAR_PAX_INTERCHANGE)
set_format_pax_restricted(archive::Reader) = set_format(archive, Format.TAR_PAX_RESTRICTED)
set_format_raw(archive::Reader) = set_format(archive, Format.RAW)
# Write only formats
# set_format_shar(archive::Reader) = set_format(archive, Format.SHAR_BASE)
# set_format_shar_dump(archive::Reader) = set_format(archive, Format.SHAR_DUMP)
set_format_ustar(archive::Reader) = set_format(archive, Format.TAR_USTAR)
set_format_v7tar(archive::Reader) = set_format(archive, Format.TAR)
set_format_warc(archive::Reader) = set_format(archive, Format.WARC)
set_format_xar(archive::Reader) = set_format(archive, Format.XAR)
set_format_zip(archive::Reader) = set_format(archive, Format.ZIP)

# Writer

"A convenience function to set the format based on the code or name."
set_format(archive::Writer, format_code::Integer) =
    @_la_call(archive_write_set_format, (Ptr{Cvoid}, Cint),
              archive, format_code)
set_format(archive::Writer, name::AbstractString) =
    @_la_call(archive_write_set_format_by_name, (Ptr{Cvoid}, Cstring),
              archive, name)

set_format_7zip(archive::Writer) =
    @_la_call(archive_write_set_format_7zip, (Ptr{Cvoid},), archive)
set_format_ar_bsd(archive::Writer) =
    @_la_call(archive_write_set_format_ar_bsd, (Ptr{Cvoid},), archive)
set_format_ar_gnu(archive::Writer) =
    @_la_call(archive_write_set_format_ar_svr4, (Ptr{Cvoid},), archive)
# const set_format_ar_svr4 = set_format_ar_gnu
set_format_cpio(archive::Writer) =
    @_la_call(archive_write_set_format_cpio, (Ptr{Cvoid},), archive)
set_format_cpio_newc(archive::Writer) =
    @_la_call(archive_write_set_format_cpio_newc, (Ptr{Cvoid},), archive)
set_format_gnutar(archive::Writer) =
    @_la_call(archive_write_set_format_gnutar, (Ptr{Cvoid},), archive)
set_format_iso9660(archive::Writer) =
    @_la_call(archive_write_set_format_iso9660, (Ptr{Cvoid},), archive)
set_format_mtree(archive::Writer) =
    @_la_call(archive_write_set_format_mtree, (Ptr{Cvoid},), archive)
set_format_mtree_classic(archive::Writer) =
    @_la_call(archive_write_set_format_mtree_classic, (Ptr{Cvoid},), archive)
set_format_pax(archive::Writer) =
    @_la_call(archive_write_set_format_pax, (Ptr{Cvoid},), archive)
set_format_pax_restricted(archive::Writer) =
    @_la_call(archive_write_set_format_pax_restricted, (Ptr{Cvoid},), archive)
set_format_raw(archive::Writer) =
    @_la_call(archive_write_set_format_raw, (Ptr{Cvoid},), archive)
set_format_shar(archive::Writer) =
    @_la_call(archive_write_set_format_shar, (Ptr{Cvoid},), archive)
set_format_shar_dump(archive::Writer) =
    @_la_call(archive_write_set_format_shar_dump, (Ptr{Cvoid},), archive)
set_format_ustar(archive::Writer) =
    @_la_call(archive_write_set_format_ustar, (Ptr{Cvoid},), archive)
set_format_v7tar(archive::Writer) =
    @_la_call(archive_write_set_format_v7tar, (Ptr{Cvoid},), archive)
set_format_warc(archive::Writer) =
    @_la_call(archive_write_set_format_warc, (Ptr{Cvoid},), archive)
set_format_xar(archive::Writer) =
    @_la_call(archive_write_set_format_xar, (Ptr{Cvoid},), archive)
set_format_zip(archive::Writer) =
    @_la_call(archive_write_set_format_zip, (Ptr{Cvoid},), archive)
zip_set_compression_deflate(archive::Writer) =
    @_la_call(archive_write_zip_set_compression_deflate, (Ptr{Cvoid},), archive)
zip_set_compression_store(archive::Writer) =
    @_la_call(archive_write_zip_set_compression_store, (Ptr{Cvoid},), archive)

# filter (i.e. compression and other post-processing on the packed files)

# Reader

support_filter_all(archive::Reader) =
    @_la_call(archive_read_support_filter_all, (Ptr{Cvoid},), archive)
support_filter_bzip2(archive::Reader) =
    @_la_call(archive_read_support_filter_bzip2, (Ptr{Cvoid},), archive)
support_filter_compress(archive::Reader) =
    @_la_call(archive_read_support_filter_compress, (Ptr{Cvoid},), archive)
support_filter_gzip(archive::Reader) =
    @_la_call(archive_read_support_filter_gzip, (Ptr{Cvoid},), archive)
support_filter_grzip(archive::Reader) =
    @_la_call(archive_read_support_filter_grzip, (Ptr{Cvoid},), archive)
support_filter_lrzip(archive::Reader) =
    @_la_call(archive_read_support_filter_lrzip, (Ptr{Cvoid},), archive)
support_filter_lz4(archive::Reader) =
    @_la_call(archive_read_support_filter_lz4, (Ptr{Cvoid},), archive)
support_filter_lzip(archive::Reader) =
    @_la_call(archive_read_support_filter_lzip, (Ptr{Cvoid},), archive)
support_filter_lzma(archive::Reader) =
    @_la_call(archive_read_support_filter_lzma, (Ptr{Cvoid},), archive)
support_filter_lzop(archive::Reader) =
    @_la_call(archive_read_support_filter_lzop, (Ptr{Cvoid},), archive)
support_filter_none(archive::Reader) =
    @_la_call(archive_read_support_filter_none, (Ptr{Cvoid},), archive)
"""
Data is fed through the specified external program before being dearchived.
Note that this disables automatic detection of the compression format, so it
makes no sense to specify this in conjunction with any other decompression
option.
"""
support_filter_program(archive::Reader, cmd) =
    @_la_call(archive_read_support_filter_program,
              (Ptr{Cvoid}, Cstring), archive, cmd)
support_filter_program_signature(archive::Reader, cmd, sig) =
    @_la_call(archive_read_support_filter_program_signature,
              (Ptr{Cvoid}, Cstring, Ptr{Cvoid}, Csize_t),
              archive, cmd, sig, sizeof(sig))
support_filter_rpm(archive::Reader) =
    @_la_call(archive_read_support_filter_rpm, (Ptr{Cvoid},), archive)
support_filter_uu(archive::Reader) =
    @_la_call(archive_read_support_filter_uu, (Ptr{Cvoid},), archive)
support_filter_xz(archive::Reader) =
    @_la_call(archive_read_support_filter_xz, (Ptr{Cvoid},), archive)
support_filter_zstd(archive::Reader) =
    @_la_call(archive_read_support_filter_zstd, (Ptr{Cvoid},), archive)

append_filter(archive::Reader, filter) =
    @_la_call(archive_read_append_filter, (Ptr{Cvoid}, Cint), archive, filter)
append_filter_program(archive::Reader, cmd) =
    @_la_call(archive_read_append_filter_program, (Ptr{Cvoid}, Cstring),
              archive, cmd)
append_filter_program_signature(archive::Reader, cmd, sig) =
    @_la_call(archive_read_append_filter_program_signature,
              (Ptr{Cvoid}, Cstring, Ptr{Cvoid}, Csize_t),
              archive, cmd, sig, sizeof(sig))

# Writer

"A convenience function to set the filter based on the code."
add_filter(archive::Writer, filter_code::Integer) =
    @_la_call(archive_write_add_filter, (Ptr{Cvoid}, Cint),
              archive, filter_code)
add_filter(archive::Writer, name::AbstractString) =
    @_la_call(archive_write_add_filter_by_name, (Ptr{Cvoid}, Cstring),
              archive, name)
add_filter_b64encode(archive::Writer) =
    @_la_call(archive_write_add_filter_b64encode, (Ptr{Cvoid},), archive)
add_filter_bzip2(archive::Writer) =
    @_la_call(archive_write_add_filter_bzip2, (Ptr{Cvoid},), archive)
add_filter_compress(archive::Writer) =
    @_la_call(archive_write_add_filter_compress, (Ptr{Cvoid},), archive)
add_filter_grzip(archive::Writer) =
    @_la_call(archive_write_add_filter_grzip, (Ptr{Cvoid},), archive)
add_filter_gzip(archive::Writer) =
    @_la_call(archive_write_add_filter_gzip, (Ptr{Cvoid},), archive)
add_filter_lrzip(archive::Writer) =
    @_la_call(archive_write_add_filter_lrzip, (Ptr{Cvoid},), archive)
add_filter_lz4(archive::Writer) =
    @_la_call(archive_write_add_filter_lz4, (Ptr{Cvoid},), archive)
add_filter_lzip(archive::Writer) =
    @_la_call(archive_write_add_filter_lzip, (Ptr{Cvoid},), archive)
add_filter_lzma(archive::Writer) =
    @_la_call(archive_write_add_filter_lzma, (Ptr{Cvoid},), archive)
add_filter_lzop(archive::Writer) =
    @_la_call(archive_write_add_filter_lzop, (Ptr{Cvoid},), archive)
add_filter_none(archive::Writer) =
    @_la_call(archive_write_add_filter_none, (Ptr{Cvoid},), archive)
add_filter_program(archive::Writer, cmd::AbstractString) =
    @_la_call(archive_write_add_filter_program,
              (Ptr{Cvoid}, Cstring), archive, cmd)
add_filter_uuencode(archive::Writer) =
    @_la_call(archive_write_add_filter_uuencode, (Ptr{Cvoid},), archive)
add_filter_xz(archive::Writer) =
    @_la_call(archive_write_add_filter_xz, (Ptr{Cvoid},), archive)
add_filter_zstd(archive::Writer) =
    @_la_call(archive_write_add_filter_zstd, (Ptr{Cvoid},), archive)

function set_format_filter_by_ext(archive::Writer, filename, def_ext=nothing)
    if def_ext === nothing
        @_la_call(archive_write_set_format_filter_by_ext,
                  (Ptr{Cvoid}, Cstring), archive, filename)
    else
        @_la_call(archive_write_set_format_filter_by_ext_def,
                  (Ptr{Cvoid}, Cstring, Cstring), archive, filename, def_ext)
    end
end

###
# Error

struct ArchiveRetry <: Exception
    msg
end
struct ArchiveFailed <: Exception
    msg
end
struct ArchiveFatal <: Exception
    msg
end

_la_error_msg(archive::Archive) = error_string(archive)
_la_error_msg(other) = ""

@noinline function _la_error(err::Cint, obj=nothing)
    err == Status.EOF && throw(EOFError())
    err == Status.RETRY && throw(ArchiveRetry(_la_error_msg(obj)))
    if err == Status.WARN
        @warn("LibArchive: $(_la_error_msg(obj))")
        return
    end
    err == Status.FAILED && throw(ArchiveFailed(_la_error_msg(obj)))
    err == Status.FATAL && throw(ArchiveFatal(_la_error_msg(obj)))
    error("Unknown error $err")
end

macro _la_call(name, types, args...)
    call_ex = esc(:(ccall(($(QuoteNode(name)), $libarchive),
                          Cint, $types, $(args...))))
    if length(args) >= 1
        error_expr = :(_la_error(status, $(esc(args[1]))))
    else
        error_expr = :(_la_error(status))
    end
    quote
        status = $call_ex
        if status != Status.OK
            $error_expr
        end
    end
end

#

using LibArchive
using Test
import Base.Filesystem

## Version
@info("Testing libarchive $(LibArchive.version()::VersionNumber)")

@testset "Version" begin
    LibArchive.version_details()
    LibArchive.zlib_version()
    LibArchive.liblzma_version()
    LibArchive.bzlib_version()
    LibArchive.liblz4_version()
    LibArchive.libzstd_version()
end

## Error
@testset "Error translation" begin
    @test_throws EOFError LibArchive._la_error(LibArchive.Status.EOF)
    @test_throws ArchiveRetry LibArchive._la_error(LibArchive.Status.RETRY)
    @test_throws ArchiveFailed LibArchive._la_error(LibArchive.Status.FAILED)
    @test_throws ArchiveFatal LibArchive._la_error(LibArchive.Status.FATAL)
    @test_throws ErrorException LibArchive._la_error(Cint(-1024))
end

## Reader error
@testset "Reader error handling" begin
    let
        local reader = LibArchive.Reader()
        @test reader.ptr != C_NULL
        LibArchive.free(reader)
        @test reader.ptr == C_NULL
        LibArchive.free(reader)
        @test_throws ErrorException LibArchive.support_filter_all(reader)
    end

    LibArchive.Reader() do reader
        LibArchive.set_exception(reader, EOFError())
        @test Libc.errno(reader) == LibArchive.Status.EOF
        @test LibArchive.error_string(reader) == "end of file"
        LibArchive.clear_error(reader)

        LibArchive.set_exception(reader, ArchiveRetry("retry"))
        @test Libc.errno(reader) == LibArchive.Status.RETRY
        @test LibArchive.error_string(reader) == "retry"
        LibArchive.clear_error(reader)

        LibArchive.set_exception(reader, ArchiveFailed("failed"))
        @test Libc.errno(reader) == LibArchive.Status.FAILED
        @test LibArchive.error_string(reader) == "failed"
        LibArchive.clear_error(reader)

        LibArchive.set_exception(reader, ArchiveFatal("fatal"))
        @test Libc.errno(reader) == LibArchive.Status.FATAL
        @test LibArchive.error_string(reader) == "fatal"
        LibArchive.Reader() do reader2
            LibArchive.copy_error(reader2, reader)
            @test Libc.errno(reader2) == LibArchive.Status.FATAL
            @test LibArchive.error_string(reader2) == "fatal"
        end
        LibArchive.clear_error(reader)

        err_ex = ErrorException("error")
        LibArchive.set_exception(reader, err_ex)
        @test Libc.errno(reader) == LibArchive.Status.FAILED
        @test LibArchive.error_string(reader) == string(err_ex)
        LibArchive.clear_error(reader)
    end

    LibArchive.Reader("/this_file_does_not_exist") do reader
        local ex
        try
            LibArchive.next_header(reader)
        catch ex
        end
        @test isa(ex, ArchiveFatal)
        @test !isempty(ex.msg)
    end
end

# Writer error
@testset "Writer error handling" begin
    let
        writer = LibArchive.Writer()
        @test writer.ptr != C_NULL
        LibArchive.free(writer)
        @test writer.ptr == C_NULL
        LibArchive.free(writer)
        @test_throws ErrorException LibArchive.add_filter_bzip2(writer)
    end

    LibArchive.Writer("/this_dir_does_not_exist/file") do writer
        local ex
        try
            LibArchive.finish_entry(writer)
        catch ex
        end
        @test isa(ex, ArchiveFatal)
        @test !isempty(ex.msg)
    end
end

@testset "Do block result and exception pass through" begin
    @test_throws BoundsError LibArchive.Writer(_->throw(BoundsError([], 10)))
    @test_throws ArgumentError LibArchive.Reader(_->throw(ArgumentError("a")))
    @test LibArchive.Writer(_->10) === 10
    @test LibArchive.Reader(_->0.1) === 0.1
end

@testset "Availability of filters and formats" begin
    @testset "Reader" begin
        LibArchive.Reader() do reader
            LibArchive.support_filter_all(reader)
        end

        LibArchive.Reader() do reader
            LibArchive.support_filter_bzip2(reader)
            LibArchive.support_filter_compress(reader)
            LibArchive.support_filter_grzip(reader)
            LibArchive.support_filter_lrzip(reader)
            LibArchive.support_filter_lz4(reader)
            LibArchive.support_filter_lzip(reader)
            LibArchive.support_filter_lzop(reader)
            LibArchive.support_filter_lzma(reader)
            LibArchive.support_filter_rpm(reader)
            LibArchive.support_filter_uu(reader)
            LibArchive.support_filter_xz(reader)
            LibArchive.support_filter_zstd(reader)
        end

        LibArchive.Reader() do reader
            LibArchive.support_format_all(reader)
        end

        LibArchive.Reader() do reader
            LibArchive.support_format_7zip(reader)
            LibArchive.support_format_ar(reader)
            LibArchive.support_format_by_code(reader, LibArchive.Format._7ZIP)
            LibArchive.support_format_cab(reader)
            LibArchive.support_format_cpio(reader)
            LibArchive.support_format_empty(reader)
            LibArchive.support_format_gnutar(reader)
            LibArchive.support_format_iso9660(reader)
            LibArchive.support_format_lha(reader)
            LibArchive.support_format_mtree(reader)
            LibArchive.support_format_rar(reader)
            LibArchive.support_format_rar5(reader)
            LibArchive.support_format_raw(reader)
            LibArchive.support_format_tar(reader)
            LibArchive.support_format_xar(reader)
            LibArchive.support_format_warc(reader)
            LibArchive.support_format_zip(reader)
            LibArchive.support_format_zip_streamable(reader)
            LibArchive.support_format_zip_seekable(reader)
        end

        LibArchive.Reader() do reader
            LibArchive.set_format_7zip(reader)
            LibArchive.set_format_ar_bsd(reader)
            LibArchive.set_format_ar_gnu(reader)
            LibArchive.set_format_ar_svr4(reader)
            LibArchive.set_format_cpio(reader)
            LibArchive.set_format_cpio_newc(reader)
            LibArchive.set_format_gnutar(reader)
            LibArchive.set_format_iso9660(reader)
            LibArchive.set_format_mtree(reader)
            LibArchive.set_format_mtree_classic(reader)
            LibArchive.set_format_pax(reader)
            LibArchive.set_format_pax_restricted(reader)
            LibArchive.set_format_raw(reader)
            LibArchive.set_format_ustar(reader)
            LibArchive.set_format_v7tar(reader)
            LibArchive.set_format_warc(reader)
            LibArchive.set_format_xar(reader)
            LibArchive.set_format_zip(reader)
        end

        LibArchive.Reader() do reader
            LibArchive.set_format(reader, LibArchive.Format.TAR)
            LibArchive.append_filter(reader, LibArchive.FilterType.BZIP2)
        end

        LibArchive.Reader() do reader
            LibArchive.set_format(reader, "gnutar")
        end
    end

    @testset "Writer" begin
        LibArchive.Writer() do writer
            LibArchive.add_filter(writer, LibArchive.FilterType.COMPRESS)
            LibArchive.add_filter(writer, "bzip2")
        end

        LibArchive.Writer() do writer
            LibArchive.add_filter_b64encode(writer)
            LibArchive.add_filter_grzip(writer)
            LibArchive.add_filter_lrzip(writer)
            LibArchive.add_filter_lz4(writer)
            LibArchive.add_filter_lzop(writer)
            LibArchive.add_filter_uuencode(writer)
            LibArchive.add_filter_bzip2(writer)
            LibArchive.add_filter_compress(writer)
            LibArchive.add_filter_gzip(writer)
            LibArchive.add_filter_none(writer)
            if !Sys.isapple()
                LibArchive.add_filter_lzip(writer)
                LibArchive.add_filter_lzma(writer)
                LibArchive.add_filter_xz(writer)
                LibArchive.add_filter_zstd(writer)
            end
        end

        LibArchive.Writer() do writer
            LibArchive.set_format(writer, LibArchive.Format.CPIO)
            LibArchive.set_format(writer, "gnutar")
        end

        LibArchive.Writer() do writer
            LibArchive.set_format_mtree_classic(writer)
            LibArchive.set_format_v7tar(writer)
            LibArchive.set_format_7zip(writer)
            LibArchive.set_format_ar_bsd(writer)
            LibArchive.set_format_ar_svr4(writer)
            if !Sys.iswindows()
                LibArchive.set_format_cpio(writer)
            end
            LibArchive.set_format_cpio_newc(writer)
            LibArchive.set_format_gnutar(writer)
            LibArchive.set_format_iso9660(writer)
            LibArchive.set_format_mtree(writer)
            LibArchive.set_format_pax(writer)
            LibArchive.set_format_pax_restricted(writer)
            LibArchive.set_format_shar(writer)
            LibArchive.set_format_shar_dump(writer)
            LibArchive.set_format_ustar(writer)
            LibArchive.set_format_xar(writer)
            LibArchive.set_format_zip(writer)
        end
    end
end

# Copy entry
@testset "Deepcopy of Entry" begin
    local entry = LibArchive.Entry()
    @test !LibArchive.size_is_set(entry)
    LibArchive.set_pathname(entry, "a.txt")
    LibArchive.set_size(entry, 10)
    LibArchive.set_perm(entry, 0o644)
    LibArchive.set_filetype(entry, LibArchive.FileType.REG)

    @test LibArchive.pathname(entry) == "a.txt"
    @test LibArchive.size(entry) == 10
    @test LibArchive.size_is_set(entry)
    @test LibArchive.perm(entry) == 0o644
    @test LibArchive.filetype(entry) == LibArchive.FileType.REG

    local entry_cp = deepcopy(entry)
    @test LibArchive.pathname(entry_cp) == "a.txt"
    @test LibArchive.size(entry_cp) == 10
    @test LibArchive.size_is_set(entry_cp)
    @test LibArchive.perm(entry_cp) == 0o644
    @test LibArchive.filetype(entry_cp) == LibArchive.FileType.REG

    LibArchive.clear(entry)
    LibArchive.free(entry)
    LibArchive.free(entry_cp)
end

# Entry properties
@testset "Entry properties" begin
    @testset "Time stamps" begin
        local entry = LibArchive.Entry()
        local t = floor(Int, time())
        local ns = rand(1:(10^8))

        @test !LibArchive.atime_is_set(entry)
        LibArchive.set_atime(entry, t, ns)
        @test LibArchive.atime_is_set(entry)
        @test LibArchive.atime(entry) == t
        @test LibArchive.atime_nsec(entry) == ns
        LibArchive.unset_atime(entry)
        @test !LibArchive.atime_is_set(entry)

        @test !LibArchive.birthtime_is_set(entry)
        LibArchive.set_birthtime(entry, t, ns)
        @test LibArchive.birthtime_is_set(entry)
        @test LibArchive.birthtime(entry) == t
        @test LibArchive.birthtime_nsec(entry) == ns
        LibArchive.unset_birthtime(entry)
        @test !LibArchive.birthtime_is_set(entry)

        @test !LibArchive.ctime_is_set(entry)
        LibArchive.set_ctime(entry, t, ns)
        @test LibArchive.ctime_is_set(entry)
        @test LibArchive.ctime(entry) == t
        @test LibArchive.ctime_nsec(entry) == ns
        LibArchive.unset_ctime(entry)
        @test !LibArchive.ctime_is_set(entry)

        @test !LibArchive.mtime_is_set(entry)
        LibArchive.set_mtime(entry, t, ns)
        @test LibArchive.mtime_is_set(entry)
        @test LibArchive.mtime(entry) == t
        @test LibArchive.mtime_nsec(entry) == ns
        LibArchive.unset_mtime(entry)
        @test !LibArchive.mtime_is_set(entry)

        LibArchive.clear(entry)
        @test !LibArchive.atime_is_set(entry)
        @test !LibArchive.birthtime_is_set(entry)
        @test !LibArchive.ctime_is_set(entry)
        @test !LibArchive.mtime_is_set(entry)
        LibArchive.free(entry)
        @test_throws ErrorException LibArchive.atime_is_set(entry)
    end

    @testset "Dev number" begin
        local entry = LibArchive.Entry()
        local dev1 = UInt64(rand(UInt32))
        # There doesn't seem to be a portable way to convert between minor and
        # major dev_t and the full dev_t
        local devmajor2 = UInt64(rand(UInt8))
        local devminor2 = UInt64(rand(UInt8))

        @test !LibArchive.dev_is_set(entry)
        LibArchive.set_dev(entry, dev1)
        @test LibArchive.dev_is_set(entry)
        @test LibArchive.dev(entry) == dev1
        LibArchive.set_devmajor(entry, devmajor2)
        LibArchive.set_devminor(entry, devminor2)
        @test LibArchive.dev_is_set(entry)
        @test LibArchive.devmajor(entry) == devmajor2
        @test LibArchive.devminor(entry) == devminor2

        LibArchive.set_rdev(entry, dev1)
        @test LibArchive.rdev(entry) == dev1
        LibArchive.set_rdevmajor(entry, devmajor2)
        LibArchive.set_rdevminor(entry, devminor2)
        @test LibArchive.rdevmajor(entry) == devmajor2
        @test LibArchive.rdevminor(entry) == devminor2

        LibArchive.clear(entry)
        @test !LibArchive.dev_is_set(entry)
        LibArchive.free(entry)
    end

    @testset "File type" begin
        local entry = LibArchive.Entry()

        for ft in (LibArchive.FileType.MT, LibArchive.FileType.REG,
                   LibArchive.FileType.LNK, LibArchive.FileType.SOCK,
                   LibArchive.FileType.CHR, LibArchive.FileType.BLK,
                   LibArchive.FileType.DIR, LibArchive.FileType.IFO)
            LibArchive.set_filetype(entry, ft)
            @test LibArchive.filetype(entry) == ft
        end

        LibArchive.free(entry)
    end

    Sys.isunix() && @testset "Flags" begin
        local entry = LibArchive.Entry()
        @test_throws ArgumentError LibArchive.fflags_text(entry)

        LibArchive.set_fflags(entry, 1, 2)
        @test LibArchive.fflags(entry) == (1, 2)
        local flags_txt = LibArchive.fflags_text(entry)
        @test !isempty(flags_txt)

        LibArchive.free(entry)

        local entry2 = LibArchive.Entry()
        @test_throws ArgumentError LibArchive.fflags_text(entry2)
        LibArchive.set_fflags(entry2, flags_txt)
        @test LibArchive.fflags(entry2) == (1, 2)
        @test LibArchive.fflags_text(entry2) == flags_txt

        LibArchive.free(entry2)
    end

    @testset "IDs / names" begin
        local entry = LibArchive.Entry()
        @test_throws ArgumentError LibArchive.gname(entry)
        @test_throws ArgumentError LibArchive.uname(entry)

        LibArchive.set_gid(entry, 2000)
        LibArchive.set_uid(entry, 2002)
        @test LibArchive.gid(entry) == 2000
        @test LibArchive.uid(entry) == 2002
        @test_throws ArgumentError LibArchive.gname(entry)
        @test_throws ArgumentError LibArchive.uname(entry)

        LibArchive.set_gname(entry, "group_name1")
        @test LibArchive.gname(entry) == "group_name1"
        if Sys.isunix()
            LibArchive.set_gname(entry, "Group αβ")
            @test LibArchive.gname(entry) == "Group αβ"
        end

        LibArchive.set_uname(entry, "user_name1")
        @test LibArchive.uname(entry) == "user_name1"
        if Sys.isunix()
            LibArchive.set_uname(entry, "User γδ")
            @test LibArchive.uname(entry) == "User γδ"
        end

        LibArchive.clear(entry)
        @test_throws ArgumentError LibArchive.gname(entry)
        @test_throws ArgumentError LibArchive.uname(entry)

        LibArchive.free(entry)
    end

    @testset "Path / links" begin
        local entry = LibArchive.Entry()

        @test_throws ArgumentError LibArchive.hardlink(entry)
        LibArchive.set_hardlink(entry, "hard_link1")
        @test LibArchive.hardlink(entry) == "hard_link1"
        if Sys.isunix()
            LibArchive.set_hardlink(entry, "Hard Link α")
            @test LibArchive.hardlink(entry) == "Hard Link α"
        end
        LibArchive.clear(entry)
        @test_throws ArgumentError LibArchive.hardlink(entry)

        @test_throws ArgumentError LibArchive.pathname(entry)
        LibArchive.set_pathname(entry, "path_name2")
        @test LibArchive.pathname(entry) == "path_name2"
        if Sys.isunix()
            LibArchive.set_pathname(entry, "Path Name β")
            @test LibArchive.pathname(entry) == "Path Name β"
        end
        LibArchive.clear(entry)
        @test_throws ArgumentError LibArchive.pathname(entry)

        @test_throws ArgumentError LibArchive.sourcepath(entry)
        LibArchive.set_sourcepath(entry, "source_path3")
        @test LibArchive.sourcepath(entry) == "source_path3"
        if Sys.isunix()
            LibArchive.set_sourcepath(entry, "Source Path γ")
            @test LibArchive.sourcepath(entry) == "Source Path γ"
        end
        LibArchive.clear(entry)
        @test_throws ArgumentError LibArchive.sourcepath(entry)

        @test_throws ArgumentError LibArchive.symlink(entry)
        LibArchive.set_symlink(entry, "sym_link4")
        @test LibArchive.symlink(entry) == "sym_link4"
        if Sys.isunix()
            LibArchive.set_symlink(entry, "Sym Link δ")
            @test LibArchive.symlink(entry) == "Sym Link δ"
        end
        @test LibArchive.symlink_type(entry) == LibArchive.SymlinkType.UNDEFINED
        LibArchive.set_symlink_type(entry, LibArchive.SymlinkType.FILE)
        @test LibArchive.symlink_type(entry) == LibArchive.SymlinkType.FILE
        LibArchive.set_symlink_type(entry, LibArchive.SymlinkType.DIRECTORY)
        @test LibArchive.symlink_type(entry) == LibArchive.SymlinkType.DIRECTORY
        LibArchive.clear(entry)
        @test_throws ArgumentError LibArchive.symlink(entry)

        LibArchive.free(entry)
    end

    @testset "inode / nlink" begin
        local entry = LibArchive.Entry()

        @test !LibArchive.ino_is_set(entry)
        LibArchive.set_ino(entry, 2345)
        @test LibArchive.ino(entry) == 2345
        LibArchive.set_nlink(entry, 10)
        @test LibArchive.nlink(entry) == 10

        LibArchive.clear(entry)
        @test !LibArchive.ino_is_set(entry)

        LibArchive.free(entry)
    end

    @testset "Permission / mode" begin
        local entry = LibArchive.Entry()

        LibArchive.set_perm(entry, 0o644)
        @test LibArchive.perm(entry) == 0o644
        local mode = LibArchive.mode(entry)
        local strmode = LibArchive.strmode(entry)
        @test mode != 0
        @test !isempty(strmode)
        LibArchive.clear(entry)

        LibArchive.set_perm(entry, 0o600)
        @test LibArchive.perm(entry) == 0o600
        LibArchive.set_mode(entry, mode)
        @test LibArchive.perm(entry) == 0o644
        @test LibArchive.mode(entry) == mode
        @test LibArchive.strmode(entry) == strmode

        LibArchive.free(entry)
    end

    @testset "Size" begin
        local entry = LibArchive.Entry()

        @test !LibArchive.size_is_set(entry)
        LibArchive.set_size(entry, 100)
        @test LibArchive.size_is_set(entry)
        @test LibArchive.size(entry) == 100
        LibArchive.unset_size(entry)
        @test !LibArchive.size_is_set(entry)

        LibArchive.free(entry)
    end

    @testset "Encryption" begin
        local entry = LibArchive.Entry()

        @test !LibArchive.is_data_encrypted(entry)
        @test !LibArchive.is_metadata_encrypted(entry)
        @test !LibArchive.is_encrypted(entry)

        LibArchive.set_is_data_encrypted(entry, true)
        LibArchive.set_is_metadata_encrypted(entry, false)
        @test LibArchive.is_data_encrypted(entry)
        @test !LibArchive.is_metadata_encrypted(entry)
        @test LibArchive.is_encrypted(entry)

        LibArchive.set_is_data_encrypted(entry, false)
        LibArchive.set_is_metadata_encrypted(entry, true)
        @test !LibArchive.is_data_encrypted(entry)
        @test LibArchive.is_metadata_encrypted(entry)
        @test LibArchive.is_encrypted(entry)

        LibArchive.set_is_data_encrypted(entry, true)
        LibArchive.set_is_metadata_encrypted(entry, true)
        @test LibArchive.is_data_encrypted(entry)
        @test LibArchive.is_metadata_encrypted(entry)
        @test LibArchive.is_encrypted(entry)

        LibArchive.free(entry)
    end
end

function create_archive(writer, passphrase=nothing, passphrase_cb=false)
    callback_called = Ref(false)
    if passphrase_cb
        LibArchive.set_passphrase(writer, ()->(callback_called[] = true; passphrase))
    elseif passphrase !== nothing
        LibArchive.set_passphrase(writer, passphrase)
    end

    entry = LibArchive.Entry(writer)
    LibArchive.set_pathname(entry, "test.txt")
    LibArchive.set_size(entry, 10)
    LibArchive.set_perm(entry, 0o644)
    LibArchive.set_filetype(entry, LibArchive.FileType.REG)
    LibArchive.write_header(writer, entry)
    write(writer, "012345678")
    write(writer, UInt8('9'))
    LibArchive.finish_entry(writer)

    entry = LibArchive.Entry(writer)
    LibArchive.set_pathname(entry, "test_a.txt")
    LibArchive.set_filetype(entry, LibArchive.FileType.LNK)
    LibArchive.set_symlink(entry, "test.txt")
    LibArchive.set_perm(entry, 0o755)
    LibArchive.write_header(writer, entry)
    LibArchive.finish_entry(writer)

    @test LibArchive.file_count(writer) == 2
    close(writer)
    @test !passphrase_cb || callback_called[]
end

function verify_archive(reader, passphrase=nothing, passphrase_cb=false)
    callback_called = Ref(false)
    if passphrase_cb
        LibArchive.set_passphrase(reader, ()->(callback_called[] = true; passphrase))
    elseif passphrase !== nothing
        LibArchive.add_passphrase(reader, passphrase)
    end

    entry = LibArchive.next_header(reader)
    @test LibArchive.pathname(entry) == "test.txt"
    @test LibArchive.size(entry) == 10
    @test LibArchive.perm(entry) == 0o644
    @test LibArchive.filetype(entry) == LibArchive.FileType.REG
    @test read(reader, String) == "0123456789"
    if passphrase !== nothing
        @test LibArchive.is_data_encrypted(entry)
    end
    LibArchive.free(entry)

    entry = LibArchive.next_header(reader)
    @test LibArchive.pathname(entry) == "test_a.txt"
    @test LibArchive.filetype(entry) == LibArchive.FileType.LNK
    @test LibArchive.symlink(entry) == "test.txt"
    @test LibArchive.perm(entry) == 0o755
    LibArchive.free(entry)

    @test_throws EOFError LibArchive.next_header(reader)
    @test LibArchive.file_count(reader) == 2
    @test !passphrase_cb || callback_called[]
end

function cd_tmpdir(cb)
    mktempdir() do d
        cd(d) do
            cb(d)
        end
    end
end

@testset "Creating and reading archive" begin
    @testset "Filename" begin
        cd_tmpdir() do d
            LibArchive.Writer("./test.tar.bz2") do writer
                LibArchive.set_format_gnutar(writer)
                LibArchive.add_filter_bzip2(writer)
                LibArchive.set_bytes_per_block(writer, 4096)
                @test LibArchive.get_bytes_per_block(writer) == 4096
                LibArchive.set_bytes_in_last_block(writer, 1)
                @test LibArchive.get_bytes_in_last_block(writer) == 1
                create_archive(writer)
                @test LibArchive.format(writer) == LibArchive.Format.TAR_GNUTAR
                @test LibArchive.format_name(writer) == "GNU tar"
            end

            LibArchive.Reader("./test.tar.bz2") do reader
                LibArchive.support_filter_bzip2(reader)
                LibArchive.support_format_gnutar(reader)
                verify_archive(reader)
                @test LibArchive.filter_count(reader) > 0
                LibArchive.filter_bytes(reader, 0)
                @test (LibArchive.filter_code(reader, 0) ==
                    LibArchive.FilterType.BZIP2)
                @test LibArchive.filter_name(reader, 0) == "bzip2"
            end
        end
    end

    Sys.isunix() && @testset "FD" begin
        cd_tmpdir() do d
            fd = ccall(:open, Cint, (Cstring, Cint, Cint),
                       "./test.tar.gz",
                       Filesystem.JL_O_WRONLY | Filesystem.JL_O_CREAT,
                       0o644)
            LibArchive.Writer(fd) do writer
                LibArchive.set_format_gnutar(writer)
                LibArchive.add_filter_gzip(writer)
                create_archive(writer)
            end
            ccall(:close, Cint, (Cint,), fd)

            fd = ccall(:open, Cint, (Cstring, Cint),
                       "./test.tar.gz", Filesystem.JL_O_RDONLY)
            LibArchive.Reader(fd) do reader
                LibArchive.support_filter_gzip(reader)
                LibArchive.support_format_gnutar(reader)
                verify_archive(reader)
            end
            ccall(:close, Cint, (Cint,), fd)
        end
    end

    @testset "In memory" begin
        local buffer = Vector{UInt8}(undef, 4096)
        local used_size = LibArchive.Writer(buffer) do writer
            LibArchive.set_format_gnutar(writer)
            LibArchive.add_filter_bzip2(writer)
            create_archive(writer)
            LibArchive.get_used(writer)
        end

        LibArchive.Reader(buffer, used_size) do reader
            LibArchive.support_filter_bzip2(reader)
            LibArchive.support_format_gnutar(reader)
            verify_archive(reader)
        end
    end

    @testset "    In memory (C pointer)" begin
        local buffer = Libc.malloc(4096)
        local used_size = LibArchive.Writer(buffer, 4096) do writer
            LibArchive.set_format_gnutar(writer)
            LibArchive.add_filter_bzip2(writer)
            create_archive(writer)
            LibArchive.get_used(writer)
        end

        LibArchive.Reader(buffer, used_size) do reader
            LibArchive.support_filter_bzip2(reader)
            LibArchive.support_format_gnutar(reader)
            verify_archive(reader)
        end
        Libc.free(buffer)
    end

    @testset "IO Stream" begin
        local io = IOBuffer()
        LibArchive.Writer(io) do writer
            LibArchive.set_format_gnutar(writer)
            LibArchive.add_filter_none(writer)
            create_archive(writer)
        end

        seek(io, 0)
        LibArchive.Reader(io) do reader
            LibArchive.support_filter_none(reader)
            LibArchive.support_format_gnutar(reader)
            verify_archive(reader)
        end
    end
end

function test_zip(passphrase, use_cb_w=false, use_cb_r=false)
    io = IOBuffer()
    LibArchive.Writer(io) do writer
        LibArchive.set_format_zip(writer)
        LibArchive.add_filter_none(writer)
        LibArchive.set_options(writer, "zip:encryption=aes128")
        create_archive(writer, passphrase, use_cb_w)
    end

    seek(io, 0)
    LibArchive.Reader(io) do reader
        LibArchive.support_filter_none(reader)
        LibArchive.support_format_zip(reader)
        verify_archive(reader, passphrase, use_cb_r)
    end
end

@testset "Passphrase" begin
    test_zip("password1234", false, false)
    test_zip("password3142", false, true)
    test_zip("password1324", true, false)
    test_zip("password2143", true, true)
end

###
# Archive entry

###
# Basic object manipulation

# This will be changed to `Cint` in libarchive 4.0
const _la_mode_t = Cushort
if Sys.isunix()
    const _Cdev_t = UInt64
else
    const _Cdev_t = Cuint
end

mutable struct Entry
    ptr::Ptr{Cvoid}
    function Entry(ptr::Ptr{Cvoid})
        obj = new(ptr)
        finalizer(obj, free)
        obj
    end
    function Entry(archive::Archive)
        ptr = ccall((:archive_entry_new2, libarchive), Ptr{Cvoid},
                    (Ptr{Cvoid},), archive)
        ptr == C_NULL && throw(OutOfMemoryError())
        Entry(ptr)
    end
    # Mostly for testing purpose
    function Entry()
        ptr = ccall((:archive_entry_new, libarchive), Ptr{Cvoid}, ())
        ptr == C_NULL && throw(OutOfMemoryError())
        Entry(ptr)
    end
end

function Base.deepcopy_internal(entry::Entry, stackdict::IdDict)
    ptr = ccall((:archive_entry_clone, libarchive),
                Ptr{Cvoid}, (Ptr{Cvoid},), entry)
    ptr == C_NULL && throw(OutOfMemoryError())
    new_entry = Entry(ptr)
    stackdict[entry] = new_entry
    new_entry
end

function clear(entry::Entry)
    ccall((:archive_entry_clear, libarchive), Ptr{Cvoid}, (Ptr{Cvoid},), entry)
    entry
end

function free(entry::Entry)
    ptr = entry.ptr
    ptr == C_NULL && return
    ccall((:archive_entry_free, libarchive), Cvoid, (Ptr{Cvoid},), ptr)
    entry.ptr = C_NULL
    nothing
end

function Base.cconvert(::Type{Ptr{Cvoid}}, entry::Entry)
    entry.ptr == C_NULL && error("entry already freed")
    entry
end
Base.unsafe_convert(::Type{Ptr{Cvoid}}, entry::Entry) = entry.ptr

# TODO:
# As of libarchive 3.4.3, the only way to make sure all of the readers of all the string
# properties are happy is to use either the `set_*` (local encoding) function
# or the `update_*_utf8` (utf-8 encoding) function.
# We assume the input is in UTF8 so I'm going for the `update_*_utf8` one.
# The function does some encoding conversions eagerly which is not ideal.
# After https://github.com/libarchive/libarchive/pull/1389 or an equivalent fix
# we should be able to use `set_*_utf8` instead.

# Retrieve fields from an archive_entry.
#
# There are a number of implicit conversions among these fields.  For
# example, if a regular string field is set and you read the _w wide
# character field, the entry will implicitly convert narrow-to-wide
# using the current locale.  Similarly, dev values are automatically
# updated when you write devmajor or devminor and vice versa.
#
# In addition, fields can be "set" or "unset."  Unset string fields
# return NULL, non-string fields have _is_set() functions to test
# whether they've been set.  You can "unset" a string field by
# assigning NULL; non-string fields have _unset() functions to
# unset them.
#
# Note: There is one ambiguity in the above; string fields will
# also return NULL when implicit character set conversions fail.
# This is usually what you want.

atime(entry::Entry) = ccall((:archive_entry_atime, libarchive),
                            Int, (Ptr{Cvoid},), entry)
atime_nsec(entry::Entry) = ccall((:archive_entry_atime_nsec, libarchive),
                                 Clong, (Ptr{Cvoid},), entry)
atime_is_set(entry::Entry) = ccall((:archive_entry_atime_is_set, libarchive),
                                   Cint, (Ptr{Cvoid},), entry) != 0
birthtime(entry::Entry) = ccall((:archive_entry_birthtime, libarchive),
                                Int, (Ptr{Cvoid},), entry)
birthtime_nsec(entry::Entry) =
    ccall((:archive_entry_birthtime_nsec, libarchive),
          Clong, (Ptr{Cvoid},), entry)
birthtime_is_set(entry::Entry) =
    ccall((:archive_entry_birthtime_is_set, libarchive),
          Cint, (Ptr{Cvoid},), entry) != 0
ctime(entry::Entry) = ccall((:archive_entry_ctime, libarchive),
                            Int, (Ptr{Cvoid},), entry)
ctime_nsec(entry::Entry) = ccall((:archive_entry_ctime_nsec, libarchive),
                                 Clong, (Ptr{Cvoid},), entry)
ctime_is_set(entry::Entry) = ccall((:archive_entry_ctime_is_set, libarchive),
                                   Cint, (Ptr{Cvoid},), entry) != 0
dev(entry::Entry) = UInt64(ccall((:archive_entry_dev, libarchive),
                                 _Cdev_t, (Ptr{Cvoid},), entry))
dev_is_set(entry::Entry) = ccall((:archive_entry_dev_is_set, libarchive),
                                 Cint, (Ptr{Cvoid},), entry) != 0
devmajor(entry::Entry) = UInt64(ccall((:archive_entry_devmajor, libarchive),
                                      _Cdev_t, (Ptr{Cvoid},), entry))
devminor(entry::Entry) = UInt64(ccall((:archive_entry_devminor, libarchive),
                                      _Cdev_t, (Ptr{Cvoid},), entry))
filetype(entry::Entry) = Cint(ccall((:archive_entry_filetype, libarchive),
                                    _la_mode_t, (Ptr{Cvoid},), entry))
function fflags(entry::Entry)
    set = Ref{Culong}(0)
    clear = Ref{Culong}(0)
    ccall((:archive_entry_fflags, libarchive),
          Cvoid, (Ptr{Cvoid}, Ptr{Culong}, Ptr{Culong}), entry, set, clear)
    set[], clear[]
end
fflags_text(entry::Entry) =
    unsafe_string(ccall((:archive_entry_fflags_text, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))
gid(entry::Entry) =
    ccall((:archive_entry_gid, libarchive), Int64, (Ptr{Cvoid},), entry)
gname(entry::Entry) =
    unsafe_string(ccall((:archive_entry_gname_utf8, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))

hardlink(entry::Entry) =
    unsafe_string(ccall((:archive_entry_hardlink_utf8, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))
ino(entry::Entry) =
    ccall((:archive_entry_ino, libarchive), Int64, (Ptr{Cvoid},), entry)
ino_is_set(entry::Entry) =
    ccall((:archive_entry_ino_is_set, libarchive),
          Cint, (Ptr{Cvoid},), entry) != 0

mode(entry::Entry) =
    Cint(ccall((:archive_entry_mode, libarchive),
               _la_mode_t, (Ptr{Cvoid},), entry))

mtime(entry::Entry) = ccall((:archive_entry_mtime, libarchive),
                            Int, (Ptr{Cvoid},), entry)
mtime_nsec(entry::Entry) = ccall((:archive_entry_mtime_nsec, libarchive),
                                 Clong, (Ptr{Cvoid},), entry)
mtime_is_set(entry::Entry) = ccall((:archive_entry_mtime_is_set, libarchive),
                                   Cint, (Ptr{Cvoid},), entry) != 0

nlink(entry::Entry) =
    ccall((:archive_entry_nlink, libarchive), Cuint, (Ptr{Cvoid},), entry)
pathname(entry::Entry) =
    unsafe_string(ccall((:archive_entry_pathname_utf8, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))

perm(entry::Entry) =
    Cint(ccall((:archive_entry_perm, libarchive),
               _la_mode_t, (Ptr{Cvoid},), entry))
rdev(entry::Entry) =
    UInt64(ccall((:archive_entry_rdev, libarchive),
                 _Cdev_t, (Ptr{Cvoid},), entry))
rdevmajor(entry::Entry) =
    UInt64(ccall((:archive_entry_rdevmajor, libarchive),
                 _Cdev_t, (Ptr{Cvoid},), entry))
rdevminor(entry::Entry) =
    UInt64(ccall((:archive_entry_rdevminor, libarchive),
                 _Cdev_t, (Ptr{Cvoid},), entry))
sourcepath(entry::Entry) =
    unsafe_string(ccall((:archive_entry_sourcepath, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))
Base.size(entry::Entry) =
    ccall((:archive_entry_size, libarchive), Int64, (Ptr{Cvoid},), entry)
size_is_set(entry::Entry) =
    ccall((:archive_entry_size_is_set, libarchive),
          Cint, (Ptr{Cvoid},), entry) != 0
strmode(entry::Entry) =
    unsafe_string(ccall((:archive_entry_strmode, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))
symlink(entry::Entry) =
    unsafe_string(ccall((:archive_entry_symlink_utf8, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))
symlink_type(entry::Entry) =
    ccall((:archive_entry_symlink_type, libarchive), Cint, (Ptr{Cvoid},), entry)
uid(entry::Entry) =
    ccall((:archive_entry_uid, libarchive), Int64, (Ptr{Cvoid},), entry)
uname(entry::Entry) =
    unsafe_string(ccall((:archive_entry_uname_utf8, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), entry))
is_data_encrypted(entry::Entry) =
    ccall((:archive_entry_is_data_encrypted, libarchive), Cint, (Ptr{Cvoid},), entry) != 0
is_metadata_encrypted(entry::Entry) =
    ccall((:archive_entry_is_metadata_encrypted, libarchive), Cint, (Ptr{Cvoid},), entry) != 0
is_encrypted(entry::Entry) =
    ccall((:archive_entry_is_encrypted, libarchive), Cint, (Ptr{Cvoid},), entry) != 0

set_atime(entry::Entry, t, ns) =
    ccall((:archive_entry_set_atime, libarchive),
          Cvoid, (Ptr{Cvoid}, Int, Clong), entry, t, ns)
unset_atime(entry::Entry) =
    ccall((:archive_entry_unset_atime, libarchive), Cvoid, (Ptr{Cvoid},), entry)
set_birthtime(entry::Entry, t, ns) =
    ccall((:archive_entry_set_birthtime, libarchive),
          Cvoid, (Ptr{Cvoid}, Int, Clong), entry, t, ns)
unset_birthtime(entry::Entry) =
    ccall((:archive_entry_unset_birthtime, libarchive),
          Cvoid, (Ptr{Cvoid},), entry)
set_ctime(entry::Entry, t, ns) =
    ccall((:archive_entry_set_ctime, libarchive),
          Cvoid, (Ptr{Cvoid}, Int, Clong), entry, t, ns)
unset_ctime(entry::Entry) =
    ccall((:archive_entry_unset_ctime, libarchive), Cvoid, (Ptr{Cvoid},), entry)
set_dev(entry::Entry, dev) =
    ccall((:archive_entry_set_dev, libarchive),
          Cvoid, (Ptr{Cvoid}, _Cdev_t), entry, dev)
set_devmajor(entry::Entry, dev) =
    ccall((:archive_entry_set_devmajor, libarchive),
          Cvoid, (Ptr{Cvoid}, _Cdev_t), entry, dev)
set_devminor(entry::Entry, dev) =
    ccall((:archive_entry_set_devminor, libarchive),
          Cvoid, (Ptr{Cvoid}, _Cdev_t), entry, dev)
set_filetype(entry::Entry, ftype) =
    ccall((:archive_entry_set_filetype, libarchive),
          Cvoid, (Ptr{Cvoid}, Cuint), entry, ftype)
set_fflags(entry::Entry, set, clear) =
    ccall((:archive_entry_set_fflags, libarchive),
          Cvoid, (Ptr{Cvoid}, Culong, Culong), entry, set, clear)
set_fflags(entry::Entry, fflags::AbstractString) =
    (ccall((:archive_entry_copy_fflags_text, libarchive),
           Ptr{Cvoid}, (Ptr{Cvoid}, Cstring), entry, fflags); nothing)
set_gid(entry::Entry, gid) =
    ccall((:archive_entry_set_gid, libarchive),
          Cvoid, (Ptr{Cvoid}, Int64), entry, gid)
set_gname(entry::Entry, gname::AbstractString) =
    ccall((:archive_entry_update_gname_utf8, libarchive),
          Cint, (Ptr{Cvoid}, Cstring), entry, gname)
set_hardlink(entry::Entry, hl::AbstractString) =
    ccall((:archive_entry_update_hardlink_utf8, libarchive),
          Cint, (Ptr{Cvoid}, Cstring), entry, hl)
set_ino(entry::Entry, ino) =
    ccall((:archive_entry_set_ino, libarchive),
          Cvoid, (Ptr{Cvoid}, Int64), entry, ino)
set_link(entry::Entry, link::AbstractString) =
    ccall((:archive_entry_update_link_utf8, libarchive),
          Cint, (Ptr{Cvoid}, Cstring), entry, link)
set_mode(entry::Entry, mode) =
    ccall((:archive_entry_set_mode, libarchive),
          Cvoid, (Ptr{Cvoid}, _la_mode_t), entry, mode)
set_mtime(entry::Entry, t, ns) =
    ccall((:archive_entry_set_mtime, libarchive),
          Cvoid, (Ptr{Cvoid}, Int, Clong), entry, t, ns)
unset_mtime(entry::Entry) =
    ccall((:archive_entry_unset_mtime, libarchive), Cvoid, (Ptr{Cvoid},), entry)
set_nlink(entry::Entry, nlink) =
    ccall((:archive_entry_set_nlink, libarchive),
          Cvoid, (Ptr{Cvoid}, Cuint), entry, nlink)
set_pathname(entry::Entry, path::AbstractString) =
    ccall((:archive_entry_update_pathname_utf8, libarchive),
          Cint, (Ptr{Cvoid}, Cstring), entry, path)
set_perm(entry::Entry, perm) =
    ccall((:archive_entry_set_perm, libarchive),
          Cvoid, (Ptr{Cvoid}, _la_mode_t), entry, perm)
set_rdev(entry::Entry, rdev) =
    ccall((:archive_entry_set_rdev, libarchive),
          Cvoid, (Ptr{Cvoid}, _Cdev_t), entry, rdev)
set_rdevmajor(entry::Entry, rdev) =
    ccall((:archive_entry_set_rdevmajor, libarchive),
          Cvoid, (Ptr{Cvoid}, _Cdev_t), entry, rdev)
set_rdevminor(entry::Entry, rdev) =
    ccall((:archive_entry_set_rdevminor, libarchive),
          Cvoid, (Ptr{Cvoid}, _Cdev_t), entry, rdev)
set_size(entry::Entry, size) =
    ccall((:archive_entry_set_size, libarchive),
          Cvoid, (Ptr{Cvoid}, Int64), entry, size)
unset_size(entry::Entry) =
    ccall((:archive_entry_unset_size, libarchive), Cvoid, (Ptr{Cvoid},), entry)
set_sourcepath(entry::Entry, path::AbstractString) =
    ccall((:archive_entry_copy_sourcepath, libarchive),
          Cvoid, (Ptr{Cvoid}, Cstring), entry, path)
set_symlink(entry::Entry, sym::AbstractString) =
    ccall((:archive_entry_update_symlink_utf8, libarchive),
          Cint, (Ptr{Cvoid}, Cstring), entry, sym)
set_symlink_type(entry::Entry, typ) =
    ccall((:archive_entry_set_symlink_type, libarchive),
          Cvoid, (Ptr{Cvoid}, Cint), entry, typ)
set_uid(entry::Entry, uid) =
    ccall((:archive_entry_set_uid, libarchive),
          Cvoid, (Ptr{Cvoid}, Int64), entry, uid)
set_uname(entry::Entry, uname::AbstractString) =
    ccall((:archive_entry_update_uname_utf8, libarchive),
          Cint, (Ptr{Cvoid}, Cstring), entry, uname)
set_is_data_encrypted(entry::Entry, encrypted::Bool) =
    ccall((:archive_entry_set_is_data_encrypted, libarchive),
          Cvoid, (Ptr{Cvoid}, Cint), entry, encrypted)
set_is_metadata_encrypted(entry::Entry, encrypted::Bool) =
    ccall((:archive_entry_set_is_metadata_encrypted, libarchive),
          Cvoid, (Ptr{Cvoid}, Cint), entry, encrypted)

# Storage for Mac OS-specific AppleDouble metadata information.
# Apple-format tar files store a separate binary blob containing
# encoded metadata with ACL, extended attributes, etc.
# This provides a place to store that blob.
function mac_metadata(entry::Entry)
    _sz = Ref{Csize_t}()
    ptr = ccall((:archive_entry_mac_metadata, libarchive),
                Ptr{Cvoid}, (Ptr{Cvoid}, Ptr{Csize_t}), entry, _sz)
    sz = _sz[]
    data = Vector{UInt8}(undef, sz)
    ccall(:memcpy, Ptr{Cvoid}, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t), data, ptr, sz)
    data
end
set_mac_metadata(entry::Entry, data::Vector{UInt8}) =
    ccall((:archive_entry_copy_mac_metadata, libarchive),
          Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t), entry, data, sizeof(data))

# ACL routines.  This used to simply store and return text-format ACL
# strings, but that proved insufficient for a number of reasons:
#   = clients need control over uname/uid and gname/gid mappings
#   = there are many different ACL text formats
#   = would like to be able to read/convert archives containing ACLs
#     on platforms that lack ACL libraries
#
# This last point, in particular, forces me to implement a reasonably
# complete set of ACL support routines.

# Set the ACL by clearing it and adding entries one at a time.
# Unlike the POSIX.1e ACL routines, you must specify the type
# (access/default) for each entry.  Internally, the ACL data is just
# a soup of entries.  API calls here allow you to retrieve just the
# entries of interest.  This design (which goes against the spirit of
# POSIX.1e) is useful for handling archive formats that combine
# default and access information in a single ACL list.
acl_clear(entry::Entry) =
    ccall((:archive_entry_acl_clear, libarchive), Cvoid, (Ptr{Cvoid},), entry)
acl_add_entry(entry::Entry, typ, perm, tag, qual, name::AbstractString) =
    @_la_call(archive_entry_acl_add_entry,
              (Ptr{Cvoid}, Cint, Cint, Cint, Cint, Cstring),
              entry, typ, perm, tag, qual, name)

# To retrieve the ACL, first "reset", then repeatedly ask for the
# "next" entry.  The want_type parameter allows you to request only
# certain types of entries.
acl_reset(entry::Entry, want) =
    ccall((:archive_entry_acl_reset, libarchive), Cint,
          (Ptr{Cvoid}, Cint), entry, want)
function acl_next(entry::Entry, want)
    typ = Ref{Cint}()
    perm = Ref{Cint}()
    tag = Ref{Cint}()
    qual = Ref{Cint}()
    name = Ref{Ptr{UInt8}}()
    @_la_call(archive_entry_acl_next,
              (Ptr{Cvoid}, Cint, Ptr{Cint}, Ptr{Cint}, Ptr{Cint}, Ptr{Cint},
               Ptr{Ptr{UInt8}}), entry, want, typ, perm, tag, qual, name)
    typ[], perm[], tag[], qual[], unsafe_string(name[])
end

"""
Construct a text-format ACL.  The flags argument is a bitmask that
can include any of the following:

* `ACL.Type.ACCESS` - Include POSIX.1e "access" entries.
* `ACL.Type.DEFAULT` - Include POSIX.1e "default" entries.
* `ACL.Type.NFS4` - Include NFS4 entries.
* `ACL.Style.EXTRA_ID` - Include extra numeric ID field in
  each ACL entry. ('star' introduced this for POSIX.1e, this flag
  also applies to NFS4.)
* `ACL.Style.MARK_DEFAULT` - Include "default:" before each
  default ACL entry, as used in old Solaris ACLs.
"""
acl_text(entry::Entry, flags) =
    unsafe_string(ccall((:archive_entry_acl_to_text, libarchive), Ptr{UInt8},
                        (Ptr{Cvoid}, Cint), entry, flags))

acl_from_text(entry::Entry, text, typ) =
    @_la_call(archive_entry_acl_from_text, (Ptr{Cvoid}, Cstring, Cint), entry, text, typ)

"Return a count of entries matching `want`"
acl_count(entry::Entry, want) =
    ccall((:archive_entry_acl_count, libarchive), Cint, (Ptr{Cvoid}, Cint),
          entry, want)

"Return bitmask of ACL types in an archive entry"
acl_types(entry::Entry) =
    ccall((:archive_entry_acl_types, libarchive), Cint, (Ptr{Cvoid},), entry)

# Return an opaque ACL object.
# There's not yet anything clients can actually do with this...
# acl(entry::Entry) =
#     ccall((:archive_entry_acl, libarchive), Ptr{archive_acl},
#           (Ptr{Cvoid},), entry)

# extended attributes
xattr_clear(entry::Entry) =
    ccall((:archive_entry_xattr_clear, libarchive), Cvoid, (Ptr{Cvoid},), entry)
xattr_add_entry(entry::Entry, name::AbstractString, value) =
    ccall((:archive_entry_xattr_add_entry, libarchive), Cvoid,
          (Ptr{Cvoid}, Cstring, Ptr{Cvoid}, Csize_t),
          entry, name, value, sizeof(value))

# To retrieve the xattr list, first "reset", then repeatedly ask for the
# "next" entry.
xattr_count(entry::Entry) =
    ccall((:archive_entry_xattr_count, libarchive), Cint, (Ptr{Cvoid},), entry)
xattr_reset(entry::Entry) =
    ccall((:archive_entry_xattr_reset, libarchive), Cint, (Ptr{Cvoid},), entry)
function xattr_next(entry::Entry)
    name = Ref{Ptr{UInt8}}()
    value = Ref{Ptr{Cvoid}}()
    len = Ref{Csize_t}()
    @_la_call(archive_entry_xattr_next,
              (Ptr{Cvoid}, Ptr{Ptr{UInt8}}, Ptr{Ptr{Cvoid}}, Ptr{Csize_t}),
              entry, name, value, len)
    buff = Vector{UInt8}(undef, len[])
    ccall(:memcpy, Ptr{Cvoid}, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t),
          buff, value[], len[])
    unsafe_string(name[]), buff
end

# sparse
sparse_clear(entry::Entry) =
    ccall((:archive_entry_sparse_clear, libarchive), Cvoid, (Ptr{Cvoid},), entry)
sparse_add_entry(entry::Entry, offset, len) =
    ccall((:archive_entry_sparse_add_entry, libarchive), Cvoid,
          (Ptr{Cvoid}, Int64, Int64), entry, offset, len)

# To retrieve the xattr list, first "reset", then repeatedly ask for the
# "next" entry.
sparse_count(entry::Entry) =
    ccall((:archive_entry_sparse_count, libarchive), Cint, (Ptr{Cvoid},), entry)
sparse_reset(entry::Entry) =
    ccall((:archive_entry_sparse_reset, libarchive), Cint, (Ptr{Cvoid},), entry)
function sparse_next(entry::Entry)
    offset = Ref{Int64}()
    len = Ref{Int64}()
    @_la_call(archive_entry_sparse_next,
              (Ptr{Cvoid}, Ptr{Int64}, Ptr{Int64}), entry, offset, len)
    offset[], len[]
end

# TODO
# Utility to match up hardlinks.
#
# The 'struct archive_entry_linkresolver' is a cache of archive entries
# for files with multiple links.  Here's how to use it:
#   1. Create a lookup object with archive_entry_linkresolver_new()
#   2. Tell it the archive format you're using.
#   3. Hand each archive_entry to archive_entry_linkify().
#      That function will return 0, 1, or 2 entries that should
#      be written.
#   4. Call archive_entry_linkify(resolver, NULL) until
#      no more entries are returned.
#   5. Call archive_entry_linkresolver_free(resolver) to free resources.
#
# The entries returned have their hardlink and size fields updated
# appropriately.  If an entry is passed in that does not refer to
# a file with multiple links, it is returned unchanged.  The intention
# is that you should be able to simply filter all entries through
# this machine.
#
# To make things more efficient, be sure that each entry has a valid
# nlinks value.  The hardlink cache uses this to track when all links
# have been found.  If the nlinks value is zero, it will keep every
# name in the cache indefinitely, which can use a lot of memory.
#
# Note that archive_entry_size() is reset to zero if the file
# body should not be written to the archive.  Pay attention!
# struct archive_entry_linkresolver;

# There are three different strategies for marking hardlinks.
# The descriptions below name them after the best-known
# formats that rely on each strategy:
#
# "Old cpio" is the simplest, it always returns any entry unmodified.
#    As far as I know, only cpio formats use this.  Old cpio archives
#    store every link with the full body; the onus is on the dearchiver
#    to detect and properly link the files as they are restored.
# "tar" is also pretty simple; it caches a copy the first time it sees
#    any link.  Subsequent appearances are modified to be hardlink
#    references to the first one without any body.  Used by all tar
#    formats, although the newest tar formats permit the "old cpio" strategy
#    as well.  This strategy is very simple for the dearchiver,
#    and reasonably straightforward for the archiver.
# "new cpio" is trickier.  It stores the body only with the last
#    occurrence.  The complication is that we might not
#    see every link to a particular file in a single session, so
#    there's no easy way to know when we've seen the last occurrence.
#    The solution here is to queue one link until we see the next.
#    At the end of the session, you can enumerate any remaining
#    entries by calling archive_entry_linkify(NULL) and store those
#    bodies.  If you have a file with three links l1, l2, and l3,
#    you'll get the following behavior if you see all three links:
#           linkify(l1) => NULL   (the resolver stores l1 internally)
#           linkify(l2) => l1     (resolver stores l2, you write l1)
#           linkify(l3) => l2, l3 (all links seen, you can write both).
#    If you only see l1 and l2, you'll get this behavior:
#           linkify(l1) => NULL
#           linkify(l2) => l1
#           linkify(NULL) => l2   (at end, you retrieve remaining links)
#    As the name suggests, this strategy is used by newer cpio variants.
#    It's noticeably more complex for the archiver, slightly more complex
#    for the dearchiver than the tar strategy, but makes it straightforward
#    to restore a file using any link by simply continuing to scan until
#    you see a link that is stored with a body.  In contrast, the tar
#    strategy requires you to rescan the archive from the beginning to
#    correctly extract an arbitrary link.

# struct archive_entry_linkresolver *archive_entry_linkresolver_new(void);
# void archive_entry_linkresolver_set_strategy(
#     struct archive_entry_linkresolver *, Cint /* format_code */);
# void archive_entry_linkresolver_free(struct archive_entry_linkresolver *);
# void archive_entry_linkify(struct archive_entry_linkresolver *,
#     struct archive_entry **, struct archive_entry **);
# struct archive_entry *archive_entry_partial_links(
#     struct archive_entry_linkresolver *res, Cuint *links);

# Routines to bulk copy fields to/from a platform-native "struct
# stat."  Libarchive used to just store a struct stat inside of each
# archive_entry object, but this created issues when trying to
# manipulate archives on systems different than the ones they were
# created on.
# stat(entry::Entry) =
#     StatStruct(ccall((:archive_entry_stat, libarchive),
#                      Ptr{UInt8}, (Ptr{Cvoid},), entry))
# function set_stat(entry::Entry, stat)
#     ccall((:archive_entry_copy_stat, libarchive),
#           Cvoid, (Ptr{Cvoid}, Ptr{UInt8}), entry, stat)
# end

###
# Various utility libarchive functions

##
# Accessor functions to read/set various information in
# the struct archive object:

"""
Number of filters in the current filter pipeline.
Filter #0 is the one closest to the format, -1 is a synonym for the
last filter, which is always the pseudo-filter that wraps the
client callbacks.
"""
filter_count(archive::Archive) =
    ccall((:archive_filter_count, libarchive), Cint, (Ptr{Cvoid},), archive)
filter_bytes(archive::Archive, n) =
    ccall((:archive_filter_bytes, libarchive), Int64, (Ptr{Cvoid}, Cint),
          archive, n)
filter_code(archive::Archive, n) =
    ccall((:archive_filter_code, libarchive), Cint, (Ptr{Cvoid}, Cint),
          archive, n)
filter_name(archive::Archive, n) =
    unsafe_string(ccall((:archive_filter_name, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid}, Cint), archive, n))

Libc.errno(archive::Archive) =
    ccall((:archive_errno, libarchive), Cint, (Ptr{Cvoid},), archive)
function error_string(archive::Archive)
    cstr = ccall((:archive_error_string, libarchive),
                 Ptr{UInt8}, (Ptr{Cvoid},), archive)
    cstr == C_NULL ? "" : unsafe_string(cstr)
end
format_name(archive::Archive) =
    unsafe_string(ccall((:archive_format_name, libarchive),
                        Ptr{UInt8}, (Ptr{Cvoid},), archive))
format(archive::Archive) =
    ccall((:archive_format, libarchive), Cint, (Ptr{Cvoid},), archive)
clear_error(archive::Archive) =
    ccall((:archive_clear_error, libarchive), Cvoid, (Ptr{Cvoid},), archive)
set_error(archive::Archive, code, msg) =
    ccall((:archive_set_error, libarchive),
          Cvoid, (Ptr{Cvoid}, Cint, Ptr{Cchar}, Cstring), archive, code, "%s", msg)
copy_error(dest::Archive, src::Archive) =
    ccall((:archive_copy_error, libarchive),
          Cvoid, (Ptr{Cvoid}, Ptr{Cvoid}), dest, src)
file_count(archive::Archive) =
    ccall((:archive_file_count, libarchive), Cint, (Ptr{Cvoid},), archive)

function set_exception(archive::Archive, @nospecialize(ex))
    status, msg = if isa(ex, EOFError)
        Status.EOF, "end of file"
    elseif isa(ex, ArchiveRetry)
        Status.RETRY, (ex::ArchiveRetry).msg
    elseif isa(ex, ArchiveFailed)
        Status.FAILED, (ex::ArchiveFailed).msg
    elseif isa(ex, ArchiveFatal)
        Status.FATAL, (ex::ArchiveFatal).msg
    else
        Status.FAILED, string(ex)
    end
    # Only set error if there isn't already one
    Libc.errno(archive) == 0 && set_error(archive, status, msg)
    status
end

module LibArchive

using LibArchive_jll
import Base: unsafe_read, unsafe_write
import Base.Filesystem
import Base.Filesystem: mtime, symlink, ctime

@inline function finalizer(obj, func)
    Base.finalizer(func, obj)
end

export ArchiveRetry, ArchiveFailed, ArchiveFatal

include("constants.jl")

###
# Version

"""
libarchive version number
"""
function version()
    vernum = ccall((:archive_version_number, libarchive), Cint, ())
    vernum, patch = divrem(vernum, Cint(1000))
    major, minor = divrem(vernum, Cint(1000))
    VersionNumber(major, minor, patch)
end

"""
libarchive version details
"""
version_details() = unsafe_string(ccall((:archive_version_details, libarchive), Ptr{UInt8}, ()))

@inline function _version_nonnull(ptr)
    ptr == C_NULL && return nothing
    return VersionNumber(unsafe_string(ptr))
end

zlib_version() =
    _version_nonnull(ccall((:archive_zlib_version, libarchive), Ptr{UInt8}, ()))
liblzma_version() =
    _version_nonnull(ccall((:archive_liblzma_version, libarchive), Ptr{UInt8}, ()))
function bzlib_version()
    ptr = ccall((:archive_bzlib_version, libarchive), Ptr{UInt8}, ())
    ptr == C_NULL && return nothing
    return VersionNumber(split(unsafe_string(ptr), ",", limit=2)[1])
end
liblz4_version() =
    _version_nonnull(ccall((:archive_liblz4_version, libarchive), Ptr{UInt8}, ()))
libzstd_version() =
    _version_nonnull(ccall((:archive_libzstd_version, libarchive), Ptr{UInt8}, ()))

abstract type Archive <: IO end

function archive_guard(func::Function, archive::Archive)
    try
        res = func(archive)
        # Only explicitly close if the function didn't throw an error
        # otherwise, only call free to avoid overriding user exceptions
        close(archive)
        return res
    finally
        free(archive)
    end
end

mutable struct PassphraseMgr{CallbackT}
    cb::CallbackT
    res::Set{String}
    function PassphraseMgr(cb::CallbackT) where {CallbackT}
        return new{CallbackT}(cb)
    end
end

function _passphrase_cb(::Ptr{Cvoid}, mgr::PassphraseMgr)
    local res
    try
        res = mgr.cb()
    catch ex
        @warn("Error: $ex in passphrase callback.")
        return Ptr{UInt8}(0)
    end
    if res === nothing
        return Ptr{UInt8}(0)
    end
    if !isdefined(mgr, :res)
        mgr.res = Set{String}()
    end
    try
        res = convert(String, res)::String
        push!(mgr.res, res)
        return pointer(res)
    catch ex
        @warn("Error: $ex when converting passphrase to string.")
        return Ptr{UInt8}(0)
    end
end

include("error.jl")
include("callback.jl")
include("archive_utils.jl")
include("entry.jl")
include("reader.jl")
include("writer.jl")
include("format.jl")

# TODO
# /*
#  * Set archive_match object that will be used in archive_read_disk to
#  * know whether an entry should be skipped. The callback function
#  * _excluded_func will be invoked when an entry is skipped by the result
#  * of archive_match.
#  */
# int archive_read_disk_set_matching(struct archive *,
#     struct archive *_matching, void (*_excluded_func)
#     (struct archive *, void *, struct archive_entry *),
#     void *_client_data);
# int archive_read_disk_set_metadata_filter_callback(struct archive *,
#     int (*_metadata_filter_func)(struct archive *, void *,
#          struct archive_entry *), void *_client_data);

# /*
#  * ARCHIVE_MATCH API
#  */
# struct archive *archive_match_new(void);
# int archive_match_free(struct archive *);

# /*
#  * Test if archive_entry is excluded.
#  * This is a convenience function. This is the same as calling all
#  * archive_match_path_excluded, archive_match_time_excluded
#  * and archive_match_owner_excluded.
#  */
# int archive_match_excluded(struct archive *,
#     struct archive_entry *);

# /*
#  * Test if pathname is excluded. The conditions are set by following functions.
#  */
# int archive_match_path_excluded(struct archive *,
#     struct archive_entry *);
# /* Control recursive inclusion of directory content when directory is included. Default on. */
# int archive_match_set_inclusion_recursion(struct archive *, int);
# /* Add exclusion pathname pattern. */
# int archive_match_exclude_pattern(struct archive *, const char *);
# /* Add exclusion pathname pattern from file. */
# int archive_match_exclude_pattern_from_file(struct archive *,
#     const char *, int _nullSeparator);
# /* Add inclusion pathname pattern. */
# int archive_match_include_pattern(struct archive *, const char *);
# /* Add inclusion pathname pattern from file. */
# int archive_match_include_pattern_from_file(struct archive *,
#     const char *, int _nullSeparator);
# /*
#  * How to get statistic information for inclusion patterns.
#  */
# /* Return the amount number of unmatched inclusion patterns. */
# int archive_match_path_unmatched_inclusions(struct archive *);
# /* Return the pattern of unmatched inclusion with ARCHIVE_OK.
#  * Return ARCHIVE_EOF if there is no inclusion pattern. */
# int archive_match_path_unmatched_inclusions_next(
#     struct archive *, const char **);

# /*
#  * Test if a file is excluded by its time stamp.
#  * The conditions are set by following functions.
#  */
# int archive_match_time_excluded(struct archive *,
#     struct archive_entry *);

# /* Set inclusion time. */
# int archive_match_include_time(struct archive *, int _flag,
#     time_t _sec, long _nsec);
# /* Set inclusion time by a date string. */
# int archive_match_include_date(struct archive *, int _flag,
#     const char *_datestr);
# /* Set inclusion time by a particluar file. */
# int archive_match_include_file_time(struct archive *,
#     int _flag, const char *_pathname);
# /* Add exclusion entry. */
# int archive_match_exclude_entry(struct archive *,
#     int _flag, struct archive_entry *);

# /*
#  * Test if a file is excluded by its uid ,gid, uname or gname.
#  * The conditions are set by following functions.
#  */
# int archive_match_owner_excluded(struct archive *,
#     struct archive_entry *);
# /* Add inclusion uid, gid, uname and gname. */
# int archive_match_include_uid(struct archive *, int64_t);
# int archive_match_include_gid(struct archive *, int64_t);
# int archive_match_include_uname(struct archive *, const char *);
# int archive_match_include_gname(struct archive *, const char *);

# /*
#  * ARCHIVE_READ_DISK API
#  *
#  * This is still evolving and somewhat experimental.
#  */
# struct archive *archive_read_disk_new(void);
# /* The names for symlink modes here correspond to an old BSD
#  * command-line argument convention: -L, -P, -H */
# /* Follow all symlinks. */
# int archive_read_disk_set_symlink_logical(struct archive *);
# /* Follow no symlinks. */
# int archive_read_disk_set_symlink_physical(struct archive *);
# /* Follow symlink initially, then not. */
# int archive_read_disk_set_symlink_hybrid(struct archive *);
# /* TODO: Handle Linux stat32/stat64 ugliness. <sigh> */
# int archive_read_disk_entry_from_file(struct archive *,
#     struct archive_entry *, int /* fd */, const struct stat *);
# /* Look up gname for gid or uname for uid. */
# /* Default implementations are very, very stupid. */
# const char *archive_read_disk_gname(struct archive *, int64_t);
# const char *archive_read_disk_uname(struct archive *, int64_t);
# /* "Standard" implementation uses getpwuid_r, getgrgid_r and caches the
#  * results for performance. */
# int archive_read_disk_set_standard_lookup(struct archive *);
# /* You can install your own lookups if you like. */
# int archive_read_disk_set_gname_lookup(struct archive *,
#     void * /* private_data */,
#     const char *(* /* lookup_fn */)(void *, int64_t),
#     void (* /* cleanup_fn */)(void *));
# int archive_read_disk_set_uname_lookup(struct archive *,
#     void * /* private_data */,
#     const char *(* /* lookup_fn */)(void *, int64_t),
#     void (* /* cleanup_fn */)(void *));
# /* Start traversal. */
# int archive_read_disk_open(struct archive *, const char *);
# /*
#  * Request that current entry be visited.  If you invoke it on every
#  * directory, you'll get a physical traversal.  This is ignored if the
#  * current entry isn't a directory or a link to a directory.  So, if
#  * you invoke this on every returned path, you'll get a full logical
#  * traversal.
#  */
# int archive_read_disk_descend(struct archive *);
# int archive_read_disk_can_descend(struct archive *);
# int archive_read_disk_current_filesystem(struct archive *);
# int archive_read_disk_current_filesystem_is_synthetic(struct archive *);
# int archive_read_disk_current_filesystem_is_remote(struct archive *);
# /* Request that the access time of the entry visited by travesal be restored. */
# int  archive_read_disk_set_atime_restored(struct archive *);

# /*
#  * Set behavior. The "flags" argument selects optional behavior.
#  */
# int  archive_read_disk_set_behavior(struct archive *,
#     int flags);

# /*-
#  * ARCHIVE_WRITE_DISK API
#  *
#  * To create objects on disk:
#  *   1) Ask archive_write_disk_new for a new archive_write_disk object.
#  *   2) Set any global properties.  In particular, you probably
#  *      want to set the options.
#  *   3) For each entry:
#  *      - construct an appropriate struct archive_entry structure
#  *      - archive_write_header to create the file/dir/etc on disk
#  *      - archive_write_data to write the entry data
#  *   4) archive_write_free to cleanup the writer and release resources
#  *
#  * In particular, you can use this in conjunction with archive_read()
#  * to pull entries out of an archive and create them on disk.
#  */
# struct archive *archive_write_disk_new(void);
# /* This file will not be overwritten. */
# int archive_write_disk_set_skip_file(struct archive *,
#     int64_t, int64_t);
# /* Set flags to control how the next item gets created.
#  * This accepts a bitmask of ARCHIVE_EXTRACT_XXX flags defined above. */
# int archive_write_disk_set_options(struct archive *,
#     int flags);
# /*
#  * The lookup functions are given uname/uid (or gname/gid) pairs and
#  * return a uid (gid) suitable for this system.  These are used for
#  * restoring ownership and for setting ACLs.  The default functions
#  * are naive, they just return the uid/gid.  These are small, so reasonable
#  * for applications that don't need to preserve ownership; they
#  * are probably also appropriate for applications that are doing
#  * same-system backup and restore.
#  */
# /*
#  * The "standard" lookup functions use common system calls to lookup
#  * the uname/gname, falling back to the uid/gid if the names can't be
#  * found.  They cache lookups and are reasonably fast, but can be very
#  * large, so they are not used unless you ask for them.  In
#  * particular, these match the specifications of POSIX "pax" and old
#  * POSIX "tar".
#  */
# int archive_write_disk_set_standard_lookup(struct archive *);
# /*
#  * If neither the default (naive) nor the standard (big) functions suit
#  * your needs, you can write your own and register them.  Be sure to
#  * include a cleanup function if you have allocated private data.
#  */
# int archive_write_disk_set_group_lookup(struct archive *,
#     void * /* private_data */,
#     int64_t (*)(void *, const char *, int64_t),
#     void (* /* cleanup */)(void *));
# int archive_write_disk_set_user_lookup(struct archive *,
#     void * /* private_data */,
#     int64_t (*)(void *, const char *, int64_t),
#     void (* /* cleanup */)(void *));
# int64_t archive_write_disk_gid(struct archive *, const char *, int64_t);
# int64_t archive_write_disk_uid(struct archive *, const char *, int64_t);

end

###
# Reading an archive
#
# Basic outline for reading an archive in C:
#     1. Ask `archive_read_new` for an archive reader object.
#     2. Update any global properties as appropriate.
#        In particular, you'll certainly want to call appropriate
#        `archive_read_support_XXX` functions.
#     3. Call `archive_read_open_XXX` to open the archive
#     4. Repeatedly call `archive_read_next_header` to get information about
#        successive archive entries.  Call `archive_read_data` to extract
#        data for entries of interest.
#     5. Call `archive_read_free` to end processing.
#
# Basic outline for reading an archive in Julia:
#     1. Create a LibArchive.Reader
#     2. Update any global properties as appropriate.
#        In particular, you'll certainly want to call appropriate
#        LibArchive.support_XXX functions.
#     3. Read the entries (API TBD). LibArchive.jl will call libarchive
#        open functions if needed.
#     4. Call LibArchive.free to end processing.

abstract type ReaderData end

mutable struct Reader{T<:ReaderData} <: Archive
    data::T
    ptr::Ptr{Cvoid}
    opened::Bool
    passphrase_mgr
    function Reader{T}(data::T) where T
        ptr = ccall((:archive_read_new, libarchive), Ptr{Cvoid}, ())
        ptr == C_NULL && throw(OutOfMemoryError())
        return Reader{T}(data, ptr, false)
    end
    # For pre-openned archive. (e.g. from LibALPM)
    function Reader{T}(data::T, ptr::Ptr{Cvoid}, opened::Bool) where T
        obj = new(data, ptr, opened)
        finalizer(obj, free)
        obj
    end
end

Reader(data::T) where {T<:ReaderData} = Reader{T}(data)

function free(archive::Reader)
    ptr = archive.ptr
    ptr == C_NULL && return
    ccall((:archive_read_free, libarchive), Cint, (Ptr{Cvoid},), ptr)
    archive.ptr = C_NULL
    nothing
end

Base.close(archive::Reader) =
    @_la_call(archive_read_close, (Ptr{Cvoid},), archive)

function Base.cconvert(::Type{Ptr{Cvoid}}, archive::Reader)
    archive.ptr == C_NULL && error("archive already freed")
    archive
end
Base.unsafe_convert(::Type{Ptr{Cvoid}}, archive::Reader) = archive.ptr

function ensure_open(archive::Reader)
    archive.opened && return
    archive.opened = true
    try
        do_open(archive)
    catch
        archive.opened = false
        rethrow()
    end
    nothing
end

###
# Open filename

struct ReadFileName{T} <: ReaderData
    name::T
    block_size::Int
end

Reader(fname::AbstractString; block_size=10240) =
    Reader(ReadFileName(fname, Int(block_size)::Int))
Reader(; block_size=10240) =
    Reader(ReadFileName(nothing, Int(block_size)::Int))

function do_open(archive::Reader{ReadFileName{T}}) where T
    data = archive.data
    @_la_call(archive_read_open_filename, (Ptr{Cvoid}, Cstring, Csize_t),
              archive, data.name, data.block_size)
end

function do_open(archive::Reader{ReadFileName{Cvoid}})
    data = archive.data
    @_la_call(archive_read_open_filename, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t),
              archive, C_NULL, data.block_size)
end

struct ReadFD <: ReaderData
    fd::Cint
    block_size::Int
end

Reader(fd::Integer; block_size=10240) =
    Reader(ReadFD(Cint(fd), Int(block_size)::Int))

function do_open(archive::Reader{ReadFD})
    data = archive.data
    @_la_call(archive_read_open_fd, (Ptr{Cvoid}, Cint, Csize_t),
              archive, data.fd, data.block_size)
end

struct ReadFILE <: ReaderData
    file::Libc.FILE
end

Reader(file::Libc.FILE) = Reader(ReadFILE(file))

function do_open(archive::Reader{ReadFILE})
    data = archive.data
    @_la_call(archive_read_open_FILE, (Ptr{Cvoid}, Ptr{Cvoid}), archive, data.file)
end

struct ReadFileNames{T} <: ReaderData
    names::Vector{T}
    block_size::Int
end

"""
Use this for reading multivolume files by filenames.
NOTE: Sorting is NOT done.
"""
Reader(fnames::AbstractVector{T} where T<:AbstractString; block_size=10240) =
    Reader(ReadFileNames{T}(Vector(fnames), Int(block_size)::Int))

function do_open(archive::Reader{ReadFileNames{T}}) where T
    data = archive.data
    @_la_call(archive_read_open_filenames, (Ptr{Cvoid}, Ptr{Cstring}, Csize_t),
              archive, data.names, data.block_size)
end

###
# Open memory

struct ReadMemory{T,TO} <: ReaderData
    ptr::T
    obj::TO # Reference for GC
    size::Int
end

Reader(ptr::T, size, obj::TO=nothing) where {T<:Ptr,TO} =
    Reader(ReadMemory{T,TO}(ptr, obj, size))
Reader(ary::Vector, size=sizeof(ary)) = Reader(pointer(ary), size, ary)

Base.unsafe_convert(::Type{Ptr{Cvoid}}, mem_data::ReadMemory) = mem_data.ptr

function do_open(archive::Reader{T}) where {T<:ReadMemory}
    data = archive.data
    @_la_call(archive_read_open_memory, (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t),
              archive, data, data.size)
end

###
# Generic reader

struct GenericReadData{T} <: ReaderData
    data::T
    buff::Vector{UInt8}
end

Reader(data::T, buff_size=10240) where {T} =
    Reader(GenericReadData{T}(data, Vector{UInt8}(undef, buff_size)))

reader_open(archive::Reader, data) = nothing
function reader_readbytes end
function reader_skip end
function reader_seek end
reader_close(archive::Reader, data) = nothing

function reader_open_callback(c_archive, archive)
    try
        clear_error(archive)
        reader_open(archive, archive.data.data)
        return Libc.errno(archive) == 0 ? Cint(0) : Status.WARN
    catch ex
        return set_exception(archive, ex)
    end
end

function reader_read_callback(c_archive, archive, buff::Ptr{Ptr{Cvoid}})
    try
        clear_error(archive)
        bytes_read = reader_readbytes(archive, archive.data.data,
                                      archive.data.buff)
        unsafe_store!(buff, pointer(archive.data.buff))
        return Cssize_t(bytes_read)
    catch ex
        set_exception(archive, ex)
        return Cssize_t(0)
    end
end

function reader_skip_callback(c_archive, archive, request)
    try
        clear_error(archive)
        return Int64(reader_skip(archive, archive.data.data, request))
    catch ex
        set_exception(archive, ex)
        return Int64(0)
    end
end

function reader_seek_callback(c_archive, archive, request, whence)
    try
        clear_error(archive)
        return Int64(reader_seek(archive, archive.data.data, request, whence))
    catch ex
        set_exception(archive, ex)
        return Int64(0)
    end
end

function reader_close_callback(c_archive, archive)
    try
        clear_error(archive)
        reader_close(archive, archive.data.data)
        return Libc.errno(archive) == 0 ? Cint(0) : Status.WARN
    catch ex
        return set_exception(archive, ex)
    end
end

reader_readbytes(archive, io::IO, buff) = readbytes!(io, buff)
reader_skip(archive, io::IO, sz) =
    (skip(io, sz); sz)
function reader_seek(archive, io::IO, request, whence)
    if whence == Filesystem.SEEK_CUR
        skip(io, request)
        return position(io)
    elseif whence == Filesystem.SEEK_SET
        seek(io, request)
        return request
    elseif whence == Filesystem.SEEK_END
        seekend(io)
        skip(io, request)
        return position(io)
    else
        throw(ArgumentError("Unknown seek type: $whence"))
    end
end

function do_open(archive::Reader{T}) where {T<:GenericReadData}
    # Set various callbacks
    @_la_call(archive_read_set_callback_data,
              (Ptr{Cvoid}, Any), archive, archive)
    @_la_call(archive_read_set_open_callback,
              (Ptr{Cvoid}, Ptr{Cvoid}), archive,
              @to_open_callback(reader_open_callback, Reader{T}))
    @_la_call(archive_read_set_read_callback,
              (Ptr{Cvoid}, Ptr{Cvoid}), archive,
              @to_read_callback(reader_read_callback, Reader{T}))
    @_la_call(archive_read_set_seek_callback,
              (Ptr{Cvoid}, Ptr{Cvoid}), archive,
              @to_seek_callback(reader_seek_callback, Reader{T}))
    @_la_call(archive_read_set_skip_callback,
              (Ptr{Cvoid}, Ptr{Cvoid}), archive,
              @to_skip_callback(reader_skip_callback, Reader{T}))
    @_la_call(archive_read_set_close_callback,
              (Ptr{Cvoid}, Ptr{Cvoid}), archive,
              @to_close_callback(reader_close_callback, Reader{T}))
    @_la_call(archive_read_open1, (Ptr{Cvoid},), archive)
end

function next_header(archive::Reader)
    ensure_open(archive)
    entry = Entry(archive)
    @_la_call(archive_read_next_header2, (Ptr{Cvoid}, Ptr{Cvoid}),
              archive, entry)
    entry
end

"""
Retrieve the byte offset in UNCOMPRESSED data where last-read
header started.
"""
header_position(archive::Reader) =
    ccall((:archive_read_header_position, libarchive),
          Int64, (Ptr{Cvoid},), archive)

"""
Returns `Cint(1)` if the archive contains at least one encrypted entry.
If the archive format not support encryption at all
`ReadFormatEncryption.UNSUPPORTED` is returned.
If for any other reason (e.g. not enough data read so far)
we cannot say whether there are encrypted entries, then
`ReadFormatEncryption.DONT_KNOW` is returned.
In general, this function will return values below zero when the
reader is uncertain or totally incapable of encryption support.
When this function returns `0` you can be sure that the reader
supports encryption detection but no encrypted entries have
been found yet.

NOTE: If the metadata/header of an archive is also encrypted, you
cannot rely on the number of encrypted entries. That is why this
function does not return the number of encrypted entries but
just shows that there are some.
"""
has_encrypted_entries(archive::Reader) =
    ccall((:archive_read_has_encrypted_entries, libarchive), Cint, (Ptr{Cvoid},), archive)

"""
Returns a bitmask of capabilities that are supported by the archive format reader.
If the reader has no special capabilities, `ReadFormatCaps.NONE` is returned.
"""
format_capabilities(archive::Reader) =
    ccall((:archive_read_format_capabilities, libarchive), Cint, (Ptr{Cvoid},), archive)

"Read data from the body of an entry.  Similar to read(2)."
@inline function unsafe_archive_read(archive::Reader, ptr::Ptr{UInt8}, sz::UInt)
    nb = ccall((:archive_read_data, libarchive), Cssize_t,
               (Ptr{Cvoid}, Ptr{Cvoid}, Csize_t), archive, ptr, sz)
    nb < 0 && _la_error(Cint(nb), archive)
    nb % Csize_t
end

function Base.eof(archive::Reader)
    b = Ref{UInt8}()
    nb = ccall((:archive_read_data, libarchive), Cssize_t,
               (Ptr{Cvoid}, Ptr{UInt8}, Csize_t), archive, b, 1)
    if nb > 0
        skip(archive, -1)
        return false
    end
    return true
end

"Read data from the body of an entry.  Similar to read(2)."
function unsafe_read(archive::Reader, ptr::Ptr{UInt8}, sz::UInt)
    unsafe_archive_read(archive, ptr, sz) != sz && throw(EOFError())
    nothing
end

"Read data from the body of an entry.  Similar to read(2)."
function Base.read(archive::Reader, ::Type{UInt8})
    b = Ref{UInt8}()
    GC.@preserve b unsafe_read(archive, Base.unsafe_convert(Ptr{UInt8}, b), UInt(1))
    b[]
end

"Read data from the body of an entry.  Similar to read(2)."
function Base.readbytes!(archive::Reader, b::Array{UInt8}, nb=length(b))
    nbread = GC.@preserve b unsafe_archive_read(archive, Base.unsafe_convert(Ptr{UInt8}, b),
                                                UInt(nb))
    nbread < nb && resize!(b, nbread)
    nbread
end

"Read data from the body of an entry.  Similar to read(2)."
function Base.read(archive::Reader)
    # Maybe we can optimize this with block read?
    block_size = UInt(1024)
    res = Vector{UInt8}(undef, block_size)
    pos = 1
    GC.@preserve res while true
        ptr = Base.unsafe_convert(Ptr{UInt8}, Ref(res, pos))
        nbread = unsafe_archive_read(archive, ptr, block_size)
        if nbread < block_size
            resize!(res, nbread + pos - 1)
            return res
        end
        pos = Int(pos + block_size)
        resize!(res, pos + block_size - 1)
    end
    return res
end

"Read data from the body of an entry.  Similar to read(2)."
@inline Base.readavailable(archive::Reader) = read(archive)

"Seek within the body of an entry.  Similar to lseek(2)."
function Base.seek(archive::Reader, offset, what=Filesystem.SEEK_SET)
    res = ccall((:archive_seek_data, libarchive), Int64,
                (Ptr{Cvoid}, Int64, Cint), archive, offset, what)
    if res < 0
        _la_error(Cint(res), archive)
    end
    return archive
end
Base.skip(archive::Reader, request) = seek(archive, request, Filesystem.SEEK_CUR)
Base.seekend(archive::Reader, request=0) = seek(archive, request, Filesystem.SEEK_END)

"Skips entire entry"
Base.skip(archive::Reader) =
    @_la_call(archive_read_data_skip, (Ptr{Cvoid},), archive)

"Writes data to specified filedes"
read_into_fd(archive::Reader, fd::Integer) =
    @_la_call(archive_read_data_into_fd, (Ptr{Cvoid}, Cint), archive, fd)

Reader(f::Function) = archive_guard(f, Reader())
Reader(f::Function, args...; kws...) =
    archive_guard(f, Reader(args...; kws...))

add_passphrase(reader::Reader, passphrase::AbstractString) =
    @_la_call(archive_read_add_passphrase, (Ptr{Cvoid}, Cstring), reader, passphrase)
function set_passphrase(reader::Reader, cb::Cb) where Cb
    mgr = PassphraseMgr(cb)
    fptr = @cfunction(_passphrase_cb, Ptr{UInt8}, (Ptr{Cvoid},Ref{PassphraseMgr{Cb}}))
    GC.@preserve mgr begin
        @_la_call(archive_read_set_passphrase_callback,
                  (Ptr{Cvoid}, Ref{PassphraseMgr{Cb}}, Ptr{Cvoid}),
                  reader, mgr, fptr)
    end
    reader.passphrase_mgr = mgr
    return
end

set_format_option(reader::Reader, m::AbstractString, o::AbstractString, v::AbstractString) =
    @_la_call(archive_read_set_format_option,
              (Ptr{Cvoid}, Cstring, Cstring, Cstring), reader, m, o, v)
set_filter_option(reader::Reader, m::AbstractString, o::AbstractString, v::AbstractString) =
    @_la_call(archive_read_set_filter_option,
              (Ptr{Cvoid}, Cstring, Cstring, Cstring), reader, m, o, v)
set_option(reader::Reader, m::AbstractString, o::AbstractString, v::AbstractString) =
    @_la_call(archive_read_set_option,
              (Ptr{Cvoid}, Cstring, Cstring, Cstring), reader, m, o, v)
set_options(reader::Reader, opts::AbstractString) =
    @_la_call(archive_read_set_options, (Ptr{Cvoid}, Cstring), reader, opts)

# TODO
# /*
#  * A zero-copy version of archive_read_data that also exposes the file offset
#  * of each returned block.  Note that the client has no way to specify
#  * the desired size of the block.  The API does guarantee that offsets will
#  * be strictly increasing and that returned blocks will not overlap.
#  */
# int archive_read_data_block(struct archive *a,
#                    const void **buff, size_t *size, int64_t *offset);

# /*-
#  * Convenience function to recreate the current entry (whose header
#  * has just been read) on disk.
#  *
#  * This does quite a bit more than just copy data to disk. It also:
#  *  - Creates intermediate directories as required.
#  *  - Manages directory permissions:  non-writable directories will
#  *    be initially created with write permission enabled; when the
#  *    archive is closed, dir permissions are edited to the values specified
#  *    in the archive.
#  *  - Checks hardlinks:  hardlinks will not be extracted unless the
#  *    linked-to file was also extracted within the same session. (TODO)
#  */

# /* The "flags" argument selects optional behavior, 'OR' the flags you want. */

# int archive_read_extract(struct archive *, struct archive_entry *,
#                      int flags);
# int archive_read_extract2(struct archive *, struct archive_entry *,
#                      struct archive * /* dest */);
# void archive_read_extract_set_progress_callback(struct archive *,
#      void (*_progress_func)(void *), void *_user_data);

# /* Record the dev/ino of a file that will not be written.  This is
#  * generally set to the dev/ino of the archive being read. */
# void archive_read_extract_set_skip_file(struct archive *,
#      int64_t, int64_t);

###
# Helpers for libarchive callbacks

"""
    ssize_t archive_read_callback(struct archive*,
                                  void *client_data, const void **buffer)

Returns pointer and size of next block of data from archive.
"""
macro to_read_callback(f, T)
    :(@cfunction($f, Cssize_t, (Ptr{Cvoid}, Ref{$(esc(T))}, Ptr{Ptr{Cvoid}})))
end

"""
    int64_t archive_skip_callback(struct archive*,
                                  void *client_data, int64_t request)

Skips at most request bytes from archive and returns the skipped amount.
This may skip fewer bytes than requested; it may even skip zero bytes.
If you do skip fewer bytes than requested, libarchive will invoke your
read callback and discard data as necessary to make up the full skip.
"""
macro to_skip_callback(f, T)
    :(@cfunction($f, Int64, (Ptr{Cvoid}, Ref{$(esc(T))}, Int64)))
end

"""
    int64_t archive_seek_callback(struct archive*,
                                  void *client_data, int64_t offset, int whence)

Seeks to specified location in the file and returns the position.
Whence values are SEEK_SET, SEEK_CUR, SEEK_END from stdio.h.
Return ARCHIVE_FATAL if the seek fails for any reason.
"""
macro to_seek_callback(f, T)
    :(@cfunction($f, Int64, (Ptr{Cvoid}, Ref{$(esc(T))}, Int64, Cint)))
end

"""
    ssize_t archive_write_callback(struct archive*,
                                   void *client_data,
                                   const void *buffer, size_t length);

Returns size actually written, zero on EOF, -1 on error.
"""
macro to_write_callback(f, T)
    :(@cfunction($f, Cssize_t, (Ptr{Cvoid}, Ref{$(esc(T))}, Ptr{Cvoid}, Csize_t)))
end

"""
    int archive_open_callback(struct archive*, void *client_data)
"""
macro to_open_callback(f, T)
    :(@cfunction($f, Cint, (Ptr{Cvoid}, Ref{$(esc(T))})))
end

"""
    int archive_close_callback(struct archive*, void *client_data)
"""
macro to_close_callback(f, T)
    :(@cfunction($f, Cint, (Ptr{Cvoid}, Ref{$(esc(T))})))
end
